//-------------------------------------------------------------------------------------------
//
//  ExtSearch - plugin for FAR (c) Azartsov V.V. 1999-2000
//
//-------------------------------------------------------------------------------------------
#include "ExtSearch.hpp" 

#include "ExtChCase.cpp" //AV 16.11.99

#include "ExtSearchMix.cpp"
#include "ExtSearchReg.cpp"
#include "ExtMenu.cpp" //AV 09.11.99
#include "ExtRegExp.cpp"    
                                                             
#include "ExtClipBoard.cpp" //

#include "math.h"
#include "sys/stat.h"

#define BEGSIZE_SEARCH_RES 1024 /*砫쭮 ⢮  ⮢  ᪥  䠩*/
#define LEVEL_PROCSENDKEY 25     /*ன - 뫠   ᮮ饭  ᮢ  ᪠  䠩*/

//#include "ExtLstRegExp.cpp"
#define DefBkGrSelect 12 /*梥 䮭 뤥  㬮砭*/
#define DefClrSelect  0  /*梥 ⥪ 뤥  㬮砭*/

#define DefNumTemplFileName 3 /* 蠡   䠩  蠡 室  訡  㬮砭*/
#define DefNumTemplNumStr   4 /* 蠡  ஬ ப   蠡 室  訡  㬮砭*/

#define BottomSearchDialog        17 /*   ᪠  ।*/
#define BottomSearchInFileDialog  19 /*   ᪠  䠩*/
#define BottomReplaceDialog       19 /*   */
#define BottomReplaceInFileDialog 21 /*     䠩*/
#define BottomCfgDialog           27 /*   䨣樨*/
#define BottomChoiceReplaceDialog 10 /*   롮 ਠ */

#define DefSizeX       77 /*ਭ    㬮砭*/
#define DefCfgSizeX    77 /*ਭ   䨣樨  㬮砭*/
#define BeforeLeft     12 /*ﭨ  묨 ࠭栬     ।*/
#define WidthUnderSide 3  /*⮫騭 㯠饩  -  */
#define WidthUnder     2  /*⮫騭 㯠饩  - ᢥ, ᭨*/

//AV 03.11.99 ⮯  help-䠩
static char Help_ExtSearch[]  = "ExtSearch";   //७ 
static char Help_ExtReplace[] = "ExtReplace";  //७   
static char Help_ExtConfig[]  = "ExtConfig";   //䨣 㣨

// ਩  ।㥬 
static char ExtHistoryName[]        = "ExtSearchText";
static char HistoryName[]           = "SearchText";      
static char ExtReplaceHistoryName[] = "ExtReplaceText";
static char ReplaceHistoryName[]    = "ReplaceText";      
static char ExtMaskHistoryName[]    = "ExtMasks";
static char MaskHistoryName[]       = "Masks";      
static char ExtWord1HistoryName[]   = "ExtWord1Text";             
static char ExtWord2HistoryName[]   = "ExtWord2Text";             
static char ExtTemplateHistoryName[]= "ExtTemplateGoToError";
static char ExtPathRootPrjHistoryName[]="ExtPathRootPrj";

static char DefWord1Str[] = "0123456789_ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"; //ᨬ ᫮(⨭) -㬮砭
static char DefWord2Str[] = "񦧨"; //ᨬ ᫮(ਫ) -㬮砭 -㬮砭
static char DefTemplate[] = "/(Warning)|(Error)\\s+?(\\S+?)\\s+?(\\d+?):/"; //蠡  室  訡 -  㬮砭


static DWORD ESEARCH_RUN_PlatformID = VER_PLATFORM_WIN32_NT;

//祭 ப ࠧ⥫  ஥
static void GetWordStr( char *Buff1, char *Buff2, char *Buff3, char *Buff4 ){
  char TmpWordStr[LenSearchStr];
  GetRegKey(HKEY_CURRENT_USER,"","Word1Str", TmpWordStr, DefWord1Str, LenSearchStr);
  if( Buff1 ) strcpy( Buff1, TmpWordStr );   
  GetRegKey(HKEY_CURRENT_USER,"","Word2Str", TmpWordStr, DefWord2Str, LenSearchStr);
  if( Buff2 ) strcpy( Buff2, TmpWordStr );   
  //砥 蠡  室  訡
  char TmpTemplate[LenSearchStr];
  GetRegKey(HKEY_CURRENT_USER,"","TemplateGoToError", TmpTemplate, DefTemplate, LenSearchStr );
  if( Buff3 ) strcpy( Buff3, TmpTemplate );   
  //砥 蠡  室  訡
  char PathRootPrj[LenSearchStr];
  GetRegKey(HKEY_CURRENT_USER,"","PathRootPrj", PathRootPrj, ".\\", LenSearchStr );
  if( Buff4 ) strcpy( Buff4, PathRootPrj );   

} 

static void SetWordStr( char *Buff1, char *Buff2, char *Buff3, char *Buff4 ){
  if( Buff1 ) SetRegKey(HKEY_CURRENT_USER,"","Word1Str", Buff1    );
  if( Buff2 ) SetRegKey(HKEY_CURRENT_USER,"","Word2Str", Buff2    );
  if( Buff3 ) SetRegKey(HKEY_CURRENT_USER,"","TemplateGoToError", Buff3 );
  if( Buff4 ) SetRegKey(HKEY_CURRENT_USER,"","PathRootPrj", Buff4 );
}

//  ⠡ ᨬ - Windows Russian
//   
static void SetWinRusTable( ExtSearchReg *esr ){
 char StrAnalise[] = " ,   ";
 int NumTable = ExtSearchInfo.CharTable( FCT_DETECT, StrAnalise, strlen(StrAnalise) );
 if( NumTable != -1 ){
    if( !ExtSearchInfo.CharTable( NumTable, (char*)&esr->WinRusTable, sizeof(esr->WinRusTable) ) ){            
       esr->ExistWinRusTable = 1;
       esr->NumWinRusTable   = NumTable;
    }
 }
}

//   ଠ樥  ⥪饩 ஢
static void SetCurTable( void ){
   if( !esr->SearchInFile ){
      ExtSearchInfo.EditorControl( ECTL_GETINFO, &esr->ei );
      ExtSearchInfo.CharTable( esr->ei.TableNum, (char*)&esr->CurTable, sizeof( esr->CurTable ) );
   }
}

//᪮஢ ப  Windows Russia
void ConvertToWinRus( char *str, unsigned long len ){
   //᫨ ⠡ Windows Russia   Far  ⥪ ஢  WinRus, ४㥬  WinRus
   if( esr->ExistWinRusTable && esr->NumWinRusTable != esr->ei.TableNum )
      while( --len > 0 ) *str++ = esr->WinRusTable.EncodeTable[*str];
}

//᪮஢ ப(Windows Russia)  
void ConvertFromWinRus( char *str, unsigned long len ){
   //᫨ ⠡ Windows Russia   Far ४㥬  OEM
   if( esr->ExistWinRusTable )
      while( --len > 0 ) *str++ = esr->WinRusTable.DecodeTable[*str];
}

void ConvertToOEM( ExtSearchReg *esr, char *str, unsigned long len ){
  if( !esr->SearchInFile ){
     EditorConvertText ect;
     ect.Text       = str;
     ect.TextLength = strlen(str);
     //
     ExtSearchInfo.EditorControl( ECTL_EDITORTOOEM, &ect );
  }
  else if( esr->CodeTableSearchInFile >= 0 && esr->cts ){
     struct CharTableSet *cts = (esr->cts+esr->CodeTableSearchInFile);
     while( --len > 0 ) *str++ = cts->DecodeTable[*str];      

  }/*else if( esr->CodeTableSearchInFile == -2 ){
    WideCharToMultiByte(
       CP_OEMCP, // code page 
       0,
       str,
       -1,
       str,
       sizeof(str),
       NULL, NULL 
    );
  }*/ 
}
     
void ConvertFromOEM( ExtSearchReg *esr, char *str ){
  if( !esr->SearchInFile ){
     EditorConvertText ect;
     ect.Text       = str;
     ect.TextLength = strlen(str);
     //
     ExtSearchInfo.EditorControl( ECTL_OEMTOEDITOR, &ect );
  }
  else{   
     if( esr->CodeTableSearchInFile >= 0 && esr->cts ){
        struct CharTableSet *cts = (esr->cts+esr->CodeTableSearchInFile);
        while( *str ) *str++ = cts->EncodeTable[*str]; 
     }
  }
}

void ConvertFromOEM( ExtSearchReg *esr, char *str, unsigned long len ){
  if( !esr->SearchInFile ){
     EditorConvertText ect;
     ect.Text       = str;
     ect.TextLength = strlen(str);
     //
     ExtSearchInfo.EditorControl( ECTL_OEMTOEDITOR, &ect );
  }
  else{   
     if( esr->CodeTableSearchInFile >= 0 && esr->cts ){
        struct CharTableSet *cts = (esr->cts+esr->CodeTableSearchInFile);
        while( *str && len-- > 0 ) *str++ = cts->EncodeTable[*str]; 
     }
  }
}

//஢ઠ  ᨬ-ࠧ⥫
static CheckDelSymbol( ExtSearchReg *esr, char Symbol ){
   int stat = 1;
   char StrSymb[2] = { Symbol, '\0' };
   //⨬ ᨬ  OEM
   ConvertToOEM( esr, StrSymb, 1 );
   Symbol = StrSymb[0];

   //᫨  -ᨬ  室  祭 ᨬ ப
   if( (strchr( esr->SymbWord1Str, Symbol )  || strchr( esr->SymbWord2Str, Symbol )) )
      stat = 0;                  

   return stat;
}

//墠뢠 楫 ᫮  ⥪饩 樨  ।
static void GetCurWord( ExtSearchReg *esr, char *CurWord, char *StringText, int StringLength, int CurPos, int *BegPos ){

   if( StringLength > CurPos ){
     char *CurText = StringText + CurPos;
  
     if( *CurText && *CurText != ' ' && *CurText != '\n' && *CurText != '\t' && *CurText != '\r' ){
  
        char *EndWord = CurText;
        while( *EndWord && !CheckDelSymbol( esr, *EndWord) ) EndWord++;
     
        char *BegWord = CurText;
        while( *BegWord && (BegWord-StringText) >= 0 && !CheckDelSymbol( esr, *BegWord) ) BegWord--;
        if( BegWord != CurText ) BegWord++;
     
        if( *BegWord != '\0' ){
           if( (EndWord-BegWord) < LenCurWord ){
              strncpy( CurWord, BegWord, (EndWord-BegWord) );
              *(CurWord+(EndWord-BegWord)) = '\0';
           } 
           else{
              strncpy( CurWord, BegWord, LenCurWord-1 );
              *(CurWord+(LenCurWord-1)) = '\0'; 
           }

           if( BegPos ) *BegPos = BegWord - StringText;//AV 02.12.99

           ConvertToOEM( esr, CurWord, LenCurWord );
        }
     }
   }
}

//஢ઠ  ,   ᮪ ⥪ - ⤥쭮 ᫮
static int CheckWord( ExtSearchReg *esr, char *StringText, int CurPos ){

     char *CurText = StringText + CurPos; 

     /*஢塞 ᨬ ࠢ  ᪠ ⥪*/
     int stat;

     if( *(CurText + strlen(esr->SearchStr)) )
        stat = CheckDelSymbol( esr, *(CurText + strlen(esr->SearchStr)) );
     else stat = 1;// ப - ⮦ ࠧ⥫
     
     /*஢塞 ᨬ ᫥  ᪠ ⥪*/
     if( stat ){
         if( CurPos != 0 )
            stat = CheckDelSymbol( esr, *(CurText-1) );
         else stat = 1;//砫 ப - ⮦ ࠧ⥫
     }
     
     return stat;
}

static void SetEditorPosition( ExtSearchReg *esr, int CurLine, int CurPos, int NoCenter, int NoPos, int Reverse ){
   struct EditorSetPosition esp;

   esp.CurLine   = CurLine;
   esp.CurPos    = CurPos;
   esp.CurTabPos = -1;   
   esp.Overtype  = -1;
   esp.LeftPos   = -1;
   esp.TopScreenLine = -1;

   if( !NoPos ){
      // 祭  業஢     室  । ࠭  Y
      int CenterY;
      //祭  業஢  室  । ࠭  X
      int CenterX;
      //ਧ 室  । ࠭
      int OutScreen;
      //⥪  ⭮⥫쭮  ࠭
      int LocCurLine;

      int UpY = (int)floor(esr->ei.WindowSizeY/4.);             /*  ࠭*/
      int DnY = (int)floor( esr->ei.WindowSizeY/4.*3.+ 0.5);    /*  ࠭, 㣫塞   ஭*/
  
      if( Reverse ) CenterY = CurLine - UpY;
      else{         
         CenterY = CurLine - DnY;
         if( NoCenter && CenterY < 0 ) CenterY = CurLine - UpY;// ࢮ ࠭
      }
      if( CenterY < 0 ) CenterY = 0;

      CenterX    = CurPos - (int)(esr->ei.WindowSizeX/2);
      if( CenterX < 0 ) CenterX = 0;

      LocCurLine = CurLine - esr->ei.TopScreenLine;

      if( LocCurLine < 0 || LocCurLine >= esr->ei.WindowSizeY )
         OutScreen = 1;
      else
         OutScreen = 0;

      //ExtTestMessage( "NoCenter", NoCenter );

      //㡥६  業 (⮡ ᠣ  뢠  ⥪)
      if( (NoCenter && LocCurLine >= UpY && LocCurLine <= DnY) || OutScreen  )    
         esp.TopScreenLine = CenterY;                                                                               
      else 
         esp.TopScreenLine = esr->ei.TopScreenLine;

      //AV 15.12.99 諨  ࠭ ࠭  X
      if( (CurPos + esr->LenStrSearchTmp) >= (esr->ei.LeftPos + esr->ei.WindowSizeX) || CurPos < esr->ei.LeftPos )
            esp.LeftPos = CenterX;//AV 15.12.99
   }
   //
   ExtSearchInfo.EditorControl( ECTL_SETPOSITION, (void*)&esp );

}

static void GetInfoSelection( ExtSearchReg *esr, int BlockStartLine, int *EndLine, int *EndPos, int *BegPos, int *Width, int FromSaveSel, struct EditorSelect *save_es ){

   if( !FromSaveSel || !GetProcSaveSelectForRestore( esr->ei.EditorID, &esr->lastsel, &esr->cursel ) ){//-  뤥  ।⢥   Far
      struct EditorGetString str;
      int LastSelEnd = -1; //ᬥ饭 ᫥ ப 뤥
    
      if( EndLine ) *EndLine = BlockStartLine;
    
      for( int i = BlockStartLine; i < esr->ei.TotalLines; i++ ){
         str.StringNumber = i;
         if( ExtSearchInfo.EditorControl( ECTL_GETSTRING, &str ) == true ){
      
            if( str.SelStart == -1 && i != BlockStartLine ) break;
            else if( str.SelStart == -1 && i == (BlockStartLine + 1) ) break;
            else if( str.SelEnd == 0 ) break;//AV 15.12.99  室 ਢ 뤥  Far
      
            if( i == BlockStartLine && BegPos ){
               *BegPos = str.SelStart;
            }  
            // 砫쭮 ᬥ饭  ਭ 
            if( Width && EndPos && i == BlockStartLine && str.SelStart )
                  *Width = -str.SelStart;
       
            if( EndLine ) *EndLine = str.StringNumber;
            if( EndPos  ){
               if( str.SelEnd != -1 ){
                  *EndPos  = str.SelEnd;
                  LastSelEnd = str.SelEnd;          
               }
               else{
                  *EndPos = str.StringLength;//뤥 砥  ᥡ  ப
               }
            }
         }
         else break;
      }
     
      // 筮 ᬥ饭  ਭ 
      if( Width && EndPos ){
         *Width += *EndPos;
    
         if( LastSelEnd == -1 )
           *Width = -1;        
      }
   }else{  //-  뤥 ६  ࠭ ࠭ 
      if( save_es ){
         if( EndLine ) *EndLine = save_es->BlockStartLine + save_es->BlockHeight +  - 1;
         if( EndPos  ) *EndPos  = save_es->BlockWidth + save_es->BlockStartPos;
         if( BegPos  ) *BegPos  = save_es->BlockStartPos;
         if( Width   ) *Width   = save_es->BlockWidth;
      }
   }
}


//࠭ ࠬ ⠭⭮ 뤥
static void SaveStandardSelect ( ExtSearchReg *esr, struct EditorSelect *save_es ){
  
    struct EditorInfo temp_ei;
    ExtSearchInfo.EditorControl( ECTL_GETINFO, &temp_ei );
   
    if( temp_ei.BlockType != BTYPE_NONE ){
       save_es->BlockType      = temp_ei.BlockType;
       save_es->BlockStartLine = temp_ei.BlockStartLine;
      
       int EndLine = 0, EndPos = 0, BegPos = 0, Width = 0;
      
       GetInfoSelection( esr, save_es->BlockStartLine, &EndLine, &EndPos, &BegPos, &Width, 0, NULL );
       save_es->BlockStartPos = BegPos;
       save_es->BlockWidth    = Width;
       save_es->BlockHeight   = EndLine - save_es->BlockStartLine + 1;
    }
    else
       save_es->BlockType = BTYPE_NONE;
}

//஢ઠ 㦭  ࠭ ⥪饥 ⠭⭮ 뤥, ᫨  ᤥ
//  ,  㦭,  ।⢥ ᠬ ࠭
static void SaveStandardSelectForRestore( ExtSearchReg *esr ){
  struct EditorSelect cursel_es;
  SaveStandardSelect( esr, &cursel_es );

  InitListSel( esr->ei.EditorID, &esr->lastsel, &esr->cursel );

  if( cursel_es.BlockType != BTYPE_NONE && memcmp( &esr->cursel->extsel_es, &cursel_es, sizeof(struct EditorSelect) ) ){
     memcpy( &esr->cursel->save_es, &cursel_es, sizeof(struct EditorSelect) );
     if( esr->cursel->save_es.BlockType != BTYPE_NONE ) esr->cursel->ProcSaveSelectForRestore = 1;
  }
}

// ⠭⭮ 뤥
static void ResetStandardSelect ( ExtSearchReg *esr ){
    if( GetProcSaveSelectForRestore( esr->ei.EditorID, &esr->lastsel, &esr->cursel ) == 1 ){
       struct EditorSelect es;
       es.BlockType = BTYPE_NONE; 
       ExtSearchInfo.EditorControl( ECTL_SELECT, &es ); /*㡥६ 뤥*/
       ExtSearchInfo.EditorControl( ECTL_REDRAW, NULL );/*㥬  ।*/
       esr->cursel->ProcResetSelect = 1;//⠭ ਧ 
    }
}

//⠭ ⠭⭮ 뤥, ᯮ । ࠬ
// Reset - ਧ, ⮣  㦭  䫠 esr->ProcSaveSelectForRestore 
static void SetStandardSelect ( ExtSearchReg *esr, int Reset ){

    //AV 28.02.00
    ExtSearchInfo.EditorControl( ECTL_GETINFO, &esr->ei );
    esr->cursel = GetListSel( esr->ei.EditorID, &esr->lastsel, esr->cursel );
    //
    if( esr->cursel ){
       struct EditorSelect *es = &esr->cursel->save_es;
   
       if( es->BlockType != BTYPE_NONE && GetProcSaveSelectForRestore( esr->ei.EditorID, &esr->lastsel, &esr->cursel ) == 1 && GetProcResetSelect( esr->ei.EditorID, &esr->lastsel, &esr->cursel ) == 1){
          ExtSearchInfo.EditorControl( ECTL_SELECT, es ); /*⠭ 뤥*/
          if( Reset ) 
             esr->cursel->ProcSaveSelectForRestore = 0;
          esr->cursel->ProcResetSelect = 0;//᭨ ਧ 
       }
    }
}

/* ७ 뤥  (뤥 १ ColorAPI)*/
static int ResetSelect( int ResetScreen ){

   struct EditorColor edc;
   memset( &edc, '\0', sizeof(EditorColor) );
   
   if( ResetScreen && Sel.Set == true && Sel.StartLine != -1 ){
      edc.StringNumber = Sel.StartLine;
      edc.StartPos = Sel.StartPos;
      edc.Color        = 0;
      ExtSearchInfo.EditorControl( ECTL_ADDCOLOR, &edc );

      Sel.Set       = false;
      Sel.StartLine = -1;
      return 1;
   }

   if( !ResetScreen ){
      Sel.Set       = false;
      Sel.StartLine = -1;
   }
   return 0;
}

static void RefreshSelect( void ){

   if( Sel.Set == true && Sel.StartLine != -1 ){
   
      struct EditorColor edc;
      memset( &edc, '\0', sizeof(EditorColor) );
      
      edc.StringNumber = Sel.StartLine;
      edc.ColorItem    = 0;
      edc.StartPos     = Sel.StartPos;
      edc.EndPos       = Sel.StartPos + Sel.Width - 1;
      edc.Color        = Sel.Color;
      ExtSearchInfo.EditorControl( ECTL_ADDCOLOR, &edc );      
   }                                            
}

//*******************************************************************
// ⠭⭠ 楤,  뤥 
//*******************************************************************
static void Select( ExtSearchReg *esr, int SelStartLine, int SelStartPos, int SelWidth ){

  if( SelWidth > 0 ){//AV 21.02.00 ᫨   뤥   
     if( !esr->SelectFAR ){
        ResetSelect( 1 );
     
        Sel.Set = true;
        Sel.StartLine = SelStartLine;
        Sel.StartPos  = SelStartPos;
        Sel.Width     = SelWidth; 
     
        struct EditorGetString str;
        str.StringNumber = Sel.StartLine;
        if( ExtSearchInfo.EditorControl( ECTL_GETSTRING, &str ) ){
           if( !Sel.FindStr ) Sel.FindStr = (char*)HeapAlloc( esr->Heap, 0, Sel.Width + 1 );
           else               Sel.FindStr = (char*)HeapReAlloc( esr->Heap, 0, Sel.FindStr, Sel.Width + 1 );
           if( Sel.FindStr ){ 
              strncpy( Sel.FindStr, str.StringText + Sel.StartPos, Sel.Width );
              *(Sel.FindStr + Sel.Width) = '\0';                               
           }
        }                                               
     
        esr->bKeyDownAfterSelect = 0; //㫥 
     
        if( SetConnectToColorerDLL ){
           RefreshSelect();
           ExtSearchInfo.EditorControl( ECTL_REDRAW, NULL );/*㥬  ।*/
        }
     }else{//AV 17.01.00 뤥 ।⢠ FAR 
        struct EditorSelect edsl;
        edsl.BlockType = BTYPE_STREAM;
        edsl.BlockStartLine = SelStartLine;
        edsl.BlockStartPos  = SelStartPos;
        edsl.BlockWidth  = SelWidth;
        edsl.BlockHeight = 1;
      
        ExtSearchInfo.EditorControl( ECTL_SELECT, &edsl );

        if( esr->cursel )
           SaveStandardSelect( esr, &esr->cursel->extsel_es );//  뤥 (ᤥ ExtSeach')
        //ExtTestMessage( "Select:ExtStertPos", esr->extsel_es.BlockStartPos  );
     }
  }
}
//।塞  ᪠  砥, ᫨ ⠭ AutoSearchInSelect
static void SetAutoSearchInSelect( ExtSearchReg *esr ){
  //AV 01.12.99
  if( esr->AutoSearchInSelect && esr->FromSearch != 1 ){ // esr->ei.BlockType != BTYPE_NONE
     if( (esr->SetSelect && esr->ei.BlockType != BTYPE_NONE && GetProcSaveSelectForRestore( esr->ei.EditorID, &esr->lastsel, &esr->cursel )) || (!esr->SetSelect && esr->ei.BlockType != BTYPE_NONE) )
        esr->FromSearch = 2; //   뤥  
     else if( !esr->SetSelect && esr->ei.BlockType != BTYPE_NONE )
        esr->FromSearch = 2; //   뤥  
     else            
        esr->FromSearch = 0; //  
  }
}

static void Message_NoFindSel( void ){
   char *MsgItems[]={ GetMsg(MNoFindSel) ,GetMsg(MOk)};
   ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber, FMSG_WARNING, NULL, MsgItems, sizeof(MsgItems)/sizeof(MsgItems[0]),1);
}

static int PrePosition( ExtSearchReg *esr ){

   int FromSearch = esr->FromSearch, 
       Reverse    = esr->ReverseSearch;

   if( FromSearch == 1 ){//  ᥬ 䠩
      if( Reverse ){
         struct EditorGetString str;
         str.StringNumber = esr->ei.TotalLines-1;// 祭 ᫥ ப
         ExtSearchInfo.EditorControl( ECTL_GETSTRING, &str );
         SetEditorPosition( esr, esr->ei.TotalLines-1, str.StringLength, 0, 0, Reverse );
      }
      else
         SetEditorPosition( esr, 0, 0, 0, 0, Reverse ); //砫 䠩
   }
   else if( FromSearch == 2 ){//  뤥 
      if( esr->ei.BlockStartLine != -1 && (esr->ei.BlockType == BTYPE_STREAM || esr->ei.BlockType ==  BTYPE_COLUMN) ){
         if( Reverse ){
            int EndLineSel, EndPosSel;
            GetInfoSelection( esr, esr->ei.BlockStartLine, &EndLineSel, &EndPosSel, NULL, NULL, 1, &esr->cursel->save_es );
            SetEditorPosition( esr, EndLineSel, EndPosSel, 0, 0, Reverse );
         }else{
            int BegPosSel;
            GetInfoSelection( esr, esr->ei.BlockStartLine, NULL, NULL, &BegPosSel, NULL, 1, &esr->cursel->save_es );
            SetEditorPosition( esr, esr->ei.BlockStartLine, BegPosSel, 0, 0, Reverse );
         }
      }
      //else {
      //   Message_NoFindSel();
      //   return -1;
      //}
   }
   else{ //   ,  뢠 ࠭ ࠭  뤥
      if( esr->SetSelect && esr->cursel ){
         memset( &esr->cursel->save_es, 0, sizeof(struct EditorSelect) );
         esr->cursel->ProcSaveSelectForRestore = 0;
      }
   }


   ExtSearchInfo.EditorControl( ECTL_GETINFO, &esr->ei );
   ExtSearchInfo.EditorControl( ECTL_REDRAW, NULL );/*㥬  ।*/
   return 0;
}

//
static char StrSearchTmp_ProcSearch[LenSearchStr];
static int LenStrSearchTmp;
//
//******************************************************************
// 㭪 ४ ப ᪠
//******************************************************************
static void SetSearchStrTmp( ExtSearchReg *esr, char *_SearchStr ){ 
   strncpy( StrSearchTmp_ProcSearch, _SearchStr, LenSearchStr );

   //if( !esr->CaseSensitive && !esr->SetRegExp )
   //   struprR( StrSearchTmp_ProcSearch, 0 );
   //else if( !esr->CaseSensitive && esr->SetRegExp )
   //   struprR( StrSearchTmp_ProcSearch, 1 );// ⮫쪮 ᪨


   if( !esr->SetRegExp && !esr->CaseSensitive ) struprR( esr, StrSearchTmp_ProcSearch, 1, 0 );
//   else if( !esr->CaseSensitive && esr->SetRegExp )
//      struprR( esr, StrSearchTmp_ProcSearch, 1, 1 );// ⮫쪮 ᪨


   //AV 18.10.99
   ConvertFromOEM( esr, StrSearchTmp_ProcSearch );

   LenStrSearchTmp = strlen(StrSearchTmp_ProcSearch);
}

//ࠡ稪 訡  ࠧ ॣᯮ
static void RegExpProcError( ExtSearchReg *esr ){
   if( esr->SetRegExp ){
      if( esr->ErrRegExpReplace ){
         char *MsgItems[]={GetMsg(MExtReplaceTitle),GetMsg(MNoCorrectRXReplace),GetMsg(MOk)};
         ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
      }
      if( esr->ErrRegExpSearch  ){
         char *MsgItems[]={GetMsg(MExtSearchTitle),GetMsg(MNoCorrectRXSearch),GetMsg(MOk)};
         ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
      } 
   }
}

//  mem2   mem1
static char *memmem( char *mem1, size_t size1, char *mem2, size_t size2 ){
   if( size2 > size1 ) return NULL;
   int (*cmpproc)(const void *s1, const void *s2, size_t n) = esr->CaseSensitive ? memcmp : memicmp;

   for( int i = 0; i < size1; i ++ )
      if( (cmpproc( (void*)(mem1 + i), (void*)mem2, size2 )) == 0 ) return (mem1 + i);

   return NULL;
}

#pragma argsused
//**********************************************************************************************
//  ᭮ 楤 堭 ᪠
//**********************************************************************************************
static int ProcSearch( ExtSearchReg *esr ){

   if( esr->CheckESC && CheckForEsc() == true ) return false;//AV 27.03.00 ஢ઠ  ⨥ Esc

   //ExtTestMessage( "EditorID", esr->ei.EditorID );
             
   if( *esr->SearchStr ){//AV 10.11.99 ᫨ ,  ᪠ :)

      int i, end, CurL;


      //AV 31.01.00
      if( esr->SetSelect && (!esr->AllProc || GetProcResetSelect( esr->ei.EditorID, &esr->lastsel, &esr->cursel ) ) )
         SaveStandardSelectForRestore( esr );

      if( !esr->AllProc && (!esr->ContinueSearch || !esr->Replace) ) SetAutoSearchInSelect( esr );/*஢塞 㦭  ᪠  */

      if( esr->SetSelect && GetProcResetSelect( esr->ei.EditorID, &esr->lastsel, &esr->cursel ) )
         SetStandardSelect( esr, 0 );         

      //AV 10.11.99 ᫨ 饬  RegExp',  ன ⠭ ਭ㤨⥫쭮  ६ ᪠
      if( esr->SetRegExp ){
         esr->WordSearch     = false;
         if( esr->Replace ){
            int len = strlen( esr->ConvertReplace );   
            if( !esr->RXConvertReplace ) esr->RXConvertReplace = (char*)HeapAlloc( esr->Heap, 0, len+1 );
            else esr->RXConvertReplace = (char*)HeapReAlloc( esr->Heap, 0, esr->RXConvertReplace, len+1 ); 
            strcpy( esr->RXConvertReplace, esr->ConvertReplace );//AV 19.11.99 
         }
      }
                                                                        
      //AV 22.10.99 樮஢ 砫 ᪠
      if( !esr->Position ){
         if( PrePosition( esr ) ) return false;// ᬮ ᯮ樮஢
         esr->Position = 1;
      }
   
      int CurLine    = esr->ei.CurLine,
           CurPos    = esr->ei.CurPos,
          TotalLines = esr->ei.TotalLines;
   
      //ᬥ  :  ࢮ , ࢮ ᪥  뤥.   ᥬ 䠩 
      //                     ࢮ ᪥  墠 ᫮
      //ᬥ :  ᫥ ,  ࢮ  ᫥ ᪠  樨 ,
      //                  ᫥ ᪠  뤥.   ᥬ 䠩
   
      if( !esr->ReverseSearch ){
         CurL = CurLine;
         end = TotalLines-1;

         if( !esr->ContinueSearch && !esr->PickUpWord ) /* ᬥ頥*/;
         else{
            if( esr->Replace && esr->ContinueSearch ){
               if( esr->LenStrReplace < 0 ) CurPos += strlen( esr->ReplaceStr );
               else                         CurPos += esr->LenStrReplace;//AV 16.11.99
            }
            else if( !esr->DN_Position && !esr->Replace && (!esr->FromSearch || (esr->FromSearch && esr->ContinueSearch) ) )
               CurPos++;
            //AV 10.12.99  ⮪ ᪥ 㠫 ᨬ \b \B ^
            else if( esr->DN_Position && esr->VirtualSymbols && esr->ContinueSearch )
               CurPos++;
         }

      }
      else{
         CurL = -CurLine;
         end = 0;   

         if( !esr->ContinueSearch && !esr->PickUpWord ) /* ᬥ頥*/;
         else{                               
            if( (!esr->Replace && (!esr->FromSearch || (esr->FromSearch && esr->ContinueSearch))) || 
                (esr->Replace && esr->ContinueSearch)  
              )
               CurPos--; //砫 ப  䠩 ⨣  CurPos < 0      
         }     
      }
   
      if( esr->FromSearch == 2 ){ //  뤥 

         int Save = GetProcSaveSelectForRestore( esr->ei.EditorID, &esr->lastsel, &esr->cursel );

         if( esr->ei.BlockType == BTYPE_NONE && !Save ){//AV 31.01.00
            Message_NoFindSel();
            return false;
         }
        
         if( !esr->ReverseSearch ){
            GetInfoSelection( esr, esr->ei.BlockStartLine, &end, NULL, NULL, NULL, 1, &esr->cursel->save_es );  
         }
         else{                      
            if( !Save )
               end = -esr->ei.BlockStartLine;      
            else
               end = -esr->cursel->save_es.BlockStartLine;
         }     
      }
   
      //    ---   横 ᪠ ---
      //
      //struct EditorGetString str;
      
      // char *StringBuff = NULL;
      // *StringBuff = '\0';
   
      char *BegStr, *FindStr;
      //AV 17.12.99 ࠫ
      //char PrevSymb = 0;
      bool loop = true, find = false;
      int  SelStart;

      char *StringText, *BegStrSave, *BegSelStrSave;

      //AV 28.03.00 ⪠ ᪮                 
      struct EditorSetPosition esp; 
      memset( &esp, 0, sizeof(struct EditorSetPosition) );        
      esr->str.StringNumber = -1;// 祭 ⥪饩 ப 
      //

      //AV 17.12.99 ࠫ
      //int NoAdequacy;//AV 25.11.99 ਧ ᮮ⢥⢨  ᫮ ॣᯠ
   
      /*横  ப ।㥬 䠩*/
      while( loop && CurL <= end ) {

         //AV 16.12.99 訡 ॣ  ப ᪠
         if( esr->SetRegExp && esr->ErrRegExpSearch ) break;

         if( esr->ReverseSearch && CurPos < 0 && !CurLine ) break;//砫 䠩  ᪥ 
   
         //AV 02.11.99 ᫨ 砫 ⭮ ᪠ ⮨  砫 ப, ᬥ⨬ 
         //if( abs(CurL) == CurLine && esr->ReverseSearch && CurPos == 0 && !esr->Replace && CurL != 0 )
         if( esr->ReverseSearch && CurL != 0 && CurPos < 0 && CurL < end ){  
            CurL++; 
            CurPos = 0;                                     
         }
 
         if( esr->ReverseSearch ) i = abs(CurL);
         else         i = CurL;
                                                                
         //AV 12.01.00                                             
         //esr->str.StringNumber = i;// 祭 ⥪饩 ப
                                                                
         //AV 28.03.00 ⪠ ᪮                 
         if( i != esr->ei.CurLine ){
            esp.CurLine = i;                                     
            ExtSearchInfo.EditorControl(ECTL_SETPOSITION,&esp);
         }
         //

         loop = ExtSearchInfo.EditorControl( ECTL_GETSTRING, &esr->str );

         //
         if( loop ) {

            if( esr->StringBuff && esr->LenCurStr < (esr->str.StringLength + LenAddStr + 1) ){
               esr->LenCurStr = esr->str.StringLength + LenAddStr + 1;
               esr->StringBuff = (char*)HeapReAlloc( esr->Heap, 0, (void*)esr->StringBuff, esr->LenCurStr );
            }   
            else if( !esr->StringBuff ){
               esr->LenCurStr = esr->str.StringLength + LenAddStr + 1;               
               esr->StringBuff = (char*)HeapAlloc( esr->Heap, 0, esr->LenCurStr );    
            }                                                   

            if( !esr->StringBuff ) break;   

            //AV 02.11.99 ᫨  砫 אַ ᪠ ⮨  । ࠢ  ⥪
            if( !esr->ReverseSearch && i == CurLine ){
      
               //ਧ - 祭   ன  । Far -   । ப
               int SetCurBeyondEOL = esr->ei.Options&EOPT_CURSORBEYONDEOL;
    
               if(  i != (esr->ei.TotalLines-1) && (SetCurBeyondEOL && CurPos >= (esr->str.StringLength+2) || (!SetCurBeyondEOL && CurPos >= esr->str.StringLength)) ){//AV 16.11.99 + "\r\n"
                  CurPos = 0;//AV 25.11.99
                  CurL++;
                  continue;
               }
               else if( i == (esr->ei.TotalLines-1) && CurPos >= esr->str.StringLength )//AV 25.11.99
                  break;
                                                                
               //AV 13.12.99
               if( !esr->SetRegExp && !esr->str.StringLength ){
                  CurPos = 0;//AV 25.11.99
                  CurL++;
                  continue;
               }
            }
            //

            memcpy( esr->StringBuff, esr->str.StringText, esr->LenCurStr );
            if( esr->SetRegExp && i != esr->ei.TotalLines-1 )   
               strcat( esr->StringBuff, "\r\n" );//AV 16.11.99


            if( esr->SetRegExp ) 
               ConvertToOEM( esr, esr->StringBuff, esr->LenCurStr ); 

            if( !esr->CaseSensitive && !esr->SetRegExp )
               struprR( esr, esr->StringBuff, 0, 0 );
            //else if( !esr->CaseSensitive && esr->SetRegExp )
            //   struprR( esr, esr->StringBuff, 1, 1 );// ⮫쪮 ᪨*/

            StringText = esr->StringBuff;
            BegStrSave = esr->StringBuff;
            BegSelStrSave = esr->StringBuff;

            if( i == CurLine ){//।塞  砫 ᪠  ப  ன 稭  
              if( !esr->ReverseSearch ) StringText += CurPos;
                 //AV 02.11.99 ⠪  室 ᫮  砫쭮 ப  ⭮ ᪥
              //else           *(StringText+CurPos) = '\0';         
            }
            if( esr->FromSearch == 2 ){//  뤥   
              //AV 24.11.99
              int OffSet = 0;
              if( !esr->ReverseSearch && i == CurLine ) OffSet = CurPos;
              //             
              if( esr->str.SelEnd != -1 )
                 *(StringText+esr->str.SelEnd-OffSet) = '\0';

              if( !OffSet && !esr->ReverseSearch )
                 StringText += esr->str.SelStart;      

              //AV 21.02.00                        
              BegSelStrSave += esr->str.SelStart;
              if( esr->str.SelEnd != -1 )
                 *(BegSelStrSave + esr->str.SelEnd - esr->str.SelStart) = '\0';
              //
            }     
         }
         else{
            break;
         }
   
         if( !esr->ReverseSearch ) BegStr = StringText;
         else BegStr = StringText + strlen(StringText);
   
         FindStr = BegStr;/*⮡  */
   
         int SetBegStr = 0;//AV 29.11.99

         /*  ⭮ ப*/
         while( FindStr ){
   
            /*  ப  ⭮ ࠢ*/
            if( esr->ReverseSearch ){
               if( SetBegStr ) break;/*諨  砫 ப*/ //BegStr == StringText
               else{/*த  */

                  if( !esr->SetRegExp ) BegStr -= LenStrSearchTmp;
                  else                  BegStr --;//AV 23.11.99

                  if( BegStr < StringText ){
                     BegStr = StringText;               
                     SetBegStr = 1;
                  }
               }
            }
                                                     
            //    
            if( (!esr->SetRegExp && (FindStr = strstr( BegStr, StrSearchTmp_ProcSearch )/*memmem( BegStr, esr->LenCurStr-(BegStr-StringText), StrSearchTmp_ProcSearch, strlen(StrSearchTmp_ProcSearch))*/ ) != NULL) || 
                (esr->SetRegExp && (FindStr = StrStrRegExp( BegStr, esr->FromSearch != 2 ? BegStrSave : BegSelStrSave, BegStrSave+strlen(BegStrSave), StrSearchTmp_ProcSearch, &LenStrSearchTmp, esr, (i == esr->ei.TotalLines-1 && esr->str.SelEnd > esr->str.StringLength) ) ) != NULL)
              ){

               //⤥쭮 ᫮  ?
               if( esr->WordSearch && !CheckWord( esr, StringText, FindStr - StringText) ){

                  if( *FindStr && !esr->ReverseSearch )  BegStr = ++FindStr;                  
                  continue;
               }

               //᫨    ⥪饩 ப, .஢ઠ
               if( i == CurLine && esr->ReverseSearch )
                  if( (FindStr - BegStrSave) > CurPos ){ 
                     continue;//ᬥ⨫  砫  ⭮ ᪠            
                  }
               //AV 24.11.99 ஢ઠ  室   ࠩ 뤥  ⭮ ᪥  뤥
               if( esr->ReverseSearch && esr->FromSearch == 2 && (FindStr - BegStrSave) < esr->str.SelStart ){
                  break; //室  ᫥ ப                                                   
               }

               //ப !!!!!
               SelStart = FindStr - BegStrSave;

               //AV 21.02.00
               //if( SelStart < 0 ) SelStart = 0;

               if( esr->PutInClipBoard && !esr->AllProc ){
                  char *InClipBoard = (char*)HeapAlloc( esr->Heap, 0,LenStrSearchTmp+1 );                   
                  if( InClipBoard ){
                     strncpy( InClipBoard, FindStr, LenStrSearchTmp );
                     *(InClipBoard + LenStrSearchTmp) = '\0';
                     ConvertToWinRus( InClipBoard, LenStrSearchTmp );
                     PutClipBoard( InClipBoard );//  
                     HeapFree( esr->Heap, 0, InClipBoard );
                  }
               }    

  
               //AV 02.12.99 । 砫쭮 樨 ᫥饣 ᪠
               int NextBegPos;
               if( esr->DN_Position && !esr->ReverseSearch && !esr->Replace )
                  NextBegPos = SelStart + LenStrSearchTmp;
               else         
                  NextBegPos = SelStart;
               //

               if( esr->Replace ) 
                  SetEditorPosition( esr, i, NextBegPos, (!esr->AllProc) ? 1 : 0, (!esr->AllProc) ? 0 : 1, esr->ReverseSearch );
               else
                  SetEditorPosition( esr, i, NextBegPos, 0, (!esr->AllProc) ? 0 : 1, esr->ReverseSearch );

               //AV 31.01.00 ⥯ 뤥 㡨ࠥ  ⠭   砥
               //AV 21.02.00 뢠-뤥塞, ᫨   뫮
               if( esr->SetSelect && (!esr->AllProc || (!GetProcResetSelect( esr->ei.EditorID, &esr->lastsel, &esr->cursel ) && !esr->Replace && !esr->Count )) ){ //&& (esr->FromSearch != 2 || esr->Replace)*/
                  ResetStandardSelect( esr ); 
                  Select( esr, i, SelStart, LenStrSearchTmp );
               }                
 
               if( !esr->FindStr ) esr->FindStr = (char*)HeapAlloc( esr->Heap, 0, LenStrSearchTmp );
               else if( LenStrSearchTmp > esr->LenStrSearchTmp ) esr->FindStr = (char*)HeapReAlloc( esr->Heap, 0, esr->FindStr, LenStrSearchTmp + 1 ); 

               memcpy( esr->FindStr, FindStr, LenStrSearchTmp );
                   
               *(esr->FindStr + LenStrSearchTmp) = '\0';

               //AV 12.11.99   ॠ쭮   ॣᯮ
               esr->LenStrSearchTmp = LenStrSearchTmp;

               if( !esr->LenStrSearchTmp ) esr->VirtualSymbols = 1;
               else                        esr->VirtualSymbols = 0;
   
               if( esr->Replace ){
                  esr->NumFindForReplace ++;
   
                  if( !esr->AllProc )
                     ExtSearchInfo.EditorControl( ECTL_REDRAW, NULL );/*㥬  ।*/
               }
   
               find = true;
               loop = false;
               break;
            }

            // 訡  ࠧ ப-  ॣᯠ
            if( esr->SetRegExp && esr->ErrRegExpReplace == 1 ){
               esr->AllProc = 0; // ⬥ ⮪ 
               loop = false;
               break;
            }

            if( esr->ReverseSearch ) FindStr = BegStr;/*⮡  */
         }
         CurL++;      
      }             

      // -  !
      if( !find && !esr->NumFindForReplace && !esr->NumCount && !esr->ErrRegExpReplace && !esr->ErrRegExpSearch ){
         int NumMes = (esr->FromSearch == 2) ? MNoFindInSel : MNoFind;
         char *MsgItems[]={GetMsg(MExtSearchTitle),GetMsg(NumMes),esr->SearchStr,GetMsg(MOk)};
         ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);

         //AV 28.03.00 ⪠ ᪮                 
         //⠭ 砫 
         esp.CurLine=esr->ei.CurLine;
         esp.CurPos=esr->ei.CurPos;
         esp.TopScreenLine=esr->ei.TopScreenLine;
         esp.LeftPos=esr->ei.LeftPos;
         esp.CurTabPos=-1;
         esp.Overtype=-1;
         ExtSearchInfo.EditorControl(ECTL_SETPOSITION,&esp); 
         //    

      }

      RegExpProcError( esr );

      return find;
      
   }
   else return false;

}

//窠 ⥪  䠩  esr->StringBuff
static bool File2StringBuff( ExtSearchReg *esr ){

   int CurHandle;
   bool stat;
   int mode = esr->IsFilePrj ? O_RDONLY : O_RDONLY | O_BINARY;

   if( (CurHandle = open( esr->FilePath, mode )) >= 0 ){

      esr->LenCurStr = filelength( CurHandle );

      if( esr->LenCurStr > 0 &&           
            (esr->StringBuff == NULL && (esr->StringBuff = (char*)HeapAlloc( esr->Heap, 0, esr->LenCurStr + 1 )) != NULL) ||
            (esr->StringBuff != NULL && (esr->StringBuff = (char*)HeapReAlloc( esr->Heap, 0, esr->StringBuff, esr->LenCurStr + 1 )) != NULL)
        ){      
                                                                       
         if( esr->Replace ){

           if( (esr->ReplaceFileBuff = (char*)HeapAlloc( esr->Heap, 0, esr->LenCurStr + 1 )) != NULL &&
               (esr->TmpReplaceStr   = (char*)HeapAlloc( esr->Heap, 0, esr->LenCurStr ) ) != NULL
             ) stat = true;
           else
               stat = false;
         }
         else
            stat = true;      
      }
      else
         stat = false;

      if( stat == true && read( CurHandle, (void*)esr->StringBuff, esr->LenCurStr ) != esr->LenCurStr )
         stat = false;
      else{
         if( stat == true ){ 
            *(esr->StringBuff + esr->LenCurStr) = '\0';
            if( esr->Replace ) memcpy( esr->ReplaceFileBuff, esr->StringBuff, esr->LenCurStr );
         }
      }
 
      if( close( CurHandle ) ) stat = false; 

   }else
      stat = false;

   return stat;
}


// ࠭  䠩
inline bool StringBuff2File( ExtSearchReg *esr ){

   int CurHandle;
   bool stat;

   //뢠  ६ 塞 䠩
   if( (CurHandle = open( esr->FilePath, O_TRUNC | O_WRONLY | O_BINARY )) >= 0 ){

         if( esr->LastFileCurPos < esr->LenCurStr ){//᪮㥬 ᫨ 㦭 ⮪
            int LenRest = esr->LenCurStr - esr->LastFileCurPos; // ⪠

            esr->LenReplaceFileBuff += LenRest;

            if( esr->LenReplaceFileBuff > esr->LenCurStr )
               esr->TmpReplaceStr = (char*)HeapReAlloc( esr->Heap, 0,  esr->TmpReplaceStr, esr->LenReplaceFileBuff );

            memcpy( esr->TmpReplaceStr + (esr->LenReplaceFileBuff-LenRest), esr->ReplaceFileBuff + esr->LastFileCurPos, LenRest );
         }

         if( write( CurHandle, (void*)esr->TmpReplaceStr, esr->LenReplaceFileBuff ) != esr->LenReplaceFileBuff )
            stat = false;

      if( close( CurHandle ) ) stat = false; 

   }else
      stat = false;

   return stat;
}

//***************************************************************************
//    ⥪  䠩 (⥯   , 殢  㦥  ⠢)
//***************************************************************************
inline void ReplaceTextInFile( ExtSearchReg *esr, char *_ConvertReplace ){
   //⥪饥  
   int FileCurPos         = esr->FileCurPos;
   int LenStrReplace      = esr->LenStrReplace = strlen( _ConvertReplace );
   int LenStrSearchTmp    = esr->LenStrSearchTmp;    
   int LenBegNoFindStr    = FileCurPos - esr->LastFileCurPos;
   int LenStartReplaceBuff= esr->LenReplaceFileBuff;

   //㢥稢      ࠧ 砫쭮 ᪠ + ᪠  
   esr->LenReplaceFileBuff += (LenStrReplace + LenBegNoFindStr);
   //᫨  ॠ㥬   
   if( esr->LenReplaceFileBuff > esr->LenCurStr ) esr->TmpReplaceStr = (char*)HeapReAlloc( esr->Heap, 0, esr->TmpReplaceStr, esr->LenReplaceFileBuff );

   if( LenBegNoFindStr > 0 )//㥬      砫 ᮪( ஬ 祣  諨)
      memcpy( esr->TmpReplaceStr + LenStartReplaceBuff, esr->ReplaceFileBuff + esr->LastFileCurPos, LenBegNoFindStr );

   //㥬 ப      
   memcpy( esr->TmpReplaceStr + LenStartReplaceBuff + LenBegNoFindStr, _ConvertReplace, esr->LenStrReplace );

   //᫥   ᫥ 
   esr->LastFileCurPos = FileCurPos + LenStrSearchTmp;

   //ExtTestMessage( esr->TmpReplaceStr );
}

char *Masks[256];//ᨢ  ᪠  ᪠  䠩
// ᨢ  ᪠  ᪠  䠩
static void FillMasks( ExtSearchReg *esr ){
   char *ptr, *cur = esr->MaskStr;
   int i = 0;
   while( (ptr = strchr( cur, ',' )) != NULL ){
      Masks[i] = (char*)HeapAlloc(esr->Heap, HEAP_ZERO_MEMORY, (ptr - cur) + 1 );
      strncpy( Masks[i], cur, ptr - cur );
      cur = ptr + 1;
      i++;
   }      
   Masks[i] = (char*)HeapAlloc( esr->Heap, HEAP_ZERO_MEMORY, strlen(cur) + 1 );
   strcpy( Masks[i], cur );
   esr->MaskNumber = i + 1;//- ᮪
}
//᢮  - ᨢ  ᪠  ᪠  䠩
static void FreeMasks( ExtSearchReg *esr ){
   for( ; esr->MaskNumber != 0; esr->MaskNumber-- )
      HeapFree( esr->Heap, HEAP_ZERO_MEMORY, Masks[esr->MaskNumber-1] );
}
//஢ઠ ப  ᮢ    ᮪
static bool CheckMasks( ExtSearchReg *esr, char *FileName ){
   for( int i = 0; i < esr->MaskNumber; i ++ ){
      if( ExtSearchInfo.CmpName( Masks[i], FileName, false ) == true ) return true;
   }
   return false;
}

//**********************************************************************************************
//  ᭮ 楤 堭 ᪠  䠩
//**********************************************************************************************
static int ProcFileSearch( ExtSearchReg *esr ){

   if( esr->Replace ){
      esr->LastFileCurPos     = 0;
      esr->LenReplaceFileBuff = 0;
   }

   if( esr->CheckESC && CheckForEsc() == true ) return false;//AV 27.03.00 ஢ઠ  ⨥ Esc
  
   if( *esr->SearchStr ){//AV 10.11.99 ᫨ ,  ᪠ :)

      //AV 10.11.99 ᫨ 饬  RegExp',  ன ⠭ ਭ㤨⥫쭮  ६ ᪠
      if( esr->SetRegExp ){
         esr->WordSearch     = false;
         if( esr->Replace ){
            int len = strlen( esr->ConvertReplace );   
            if( !esr->RXConvertReplace ) esr->RXConvertReplace = (char*)HeapAlloc( esr->Heap, 0, len+1 );
            else esr->RXConvertReplace = (char*)HeapReAlloc( esr->Heap, 0, esr->RXConvertReplace, len+1 ); 
            strcpy( esr->RXConvertReplace, esr->ConvertReplace );//AV 19.11.99 
         }
      }                                                                        

      //    ---   横 ᪠ ---
      char *BegStr, *FindStr;
      bool find = false;

      char *StringText, *BegStrSave, *BegRegExpStrSave, *EndRegExpStrSave;
 
      if( !esr->StringBuff ) return false;   

      if( !esr->AllProc ){ // ⮫쪮  ࢮ 室
         if( esr->SetRegExp )
            ConvertToOEM( esr, esr->StringBuff, esr->LenCurStr ); 
      
         if( !esr->CaseSensitive && !esr->SetRegExp )
            struprR( esr, esr->StringBuff, 2, 0 );
//         else if( !esr->CaseSensitive && esr->SetRegExp )
//            struprR( esr, esr->StringBuff, 1, 1 );// ⮫쪮 ᪨*/

      }

      StringText = BegStrSave = esr->StringBuff;

      if( esr->SetRegExp ){
         BegRegExpStrSave = esr->StringBuff;
         EndRegExpStrSave = BegRegExpStrSave + esr->LenCurStr;          
      }
      if( esr->AllProc ){
         StringText += (esr->FileCurPos + 1);
         if( esr->SetRegExp )
            SetRegExpSearchStrTmp( esr, StrSearchTmp_ProcSearch, &esr->ei, 1 );
      }

      if( esr->ChangeBegStr && esr->Replace && esr->SetRegExp )
          SetRegExpSearchStrTmp( esr, StrSearchTmp_ProcSearch, &esr->ei, 2 );
      
      BegStr  = StringText;   
      FindStr = BegStr;/*⮡  */

      bool repeat = false; // ୮ ᪠  ࠡ⪮  砫 ப - ^

      bool FirstReplace = esr->Replace ? true : false;

      /*  ⥪ 䠩*/
      while( FindStr ){

         if( esr->ExitThread ){ 
            FreeMasks( esr );
            esr->ExitThread = 0; 
            _endthread();
         }

         //    
         if( (!esr->SetRegExp && (FindStr = memmem( BegStr, esr->LenCurStr-(BegStr-StringText), StrSearchTmp_ProcSearch, strlen(StrSearchTmp_ProcSearch) )) != NULL) || 
             (esr->SetRegExp && (FindStr = StrStrRegExp( BegStr, BegRegExpStrSave, EndRegExpStrSave, StrSearchTmp_ProcSearch, &LenStrSearchTmp, esr, false ) ) != NULL)
           ){

            //⤥쭮 ᫮  ?
            if( esr->WordSearch && !CheckWord( esr, StringText, FindStr - StringText) ){

               BegStr = ++FindStr;                  
               continue;
            }
            //ப !!!!!
            //SelStart = FindStr - BegStrSave;
            esr->FileCurPos = FindStr - BegStrSave;
              
            if( !esr->FindStr ) esr->FindStr = (char*)HeapAlloc( esr->Heap, 0, LenStrSearchTmp );
            else if( LenStrSearchTmp > esr->LenStrSearchTmp ) esr->FindStr = (char*)HeapReAlloc( esr->Heap, 0, esr->FindStr, LenStrSearchTmp + 1); 
            strncpy( esr->FindStr, FindStr, LenStrSearchTmp );
                
            *(esr->FindStr + LenStrSearchTmp) = '\0';
            //AV 12.11.99   ॠ쭮   ॣᯮ
            esr->LenStrSearchTmp = LenStrSearchTmp;

            if( !esr->LenStrSearchTmp ) esr->VirtualSymbols = 1;
            else                        esr->VirtualSymbols = 0;

            if( esr->Replace ){
               esr->NumFindForReplace ++;
               if( !esr->SetRegExp ) ReplaceTextInFile( esr, esr->ConvertReplace );
               else                  ReplaceTextInFile( esr, esr->RXConvertReplace );

               if( esr->LenStrSearchTmp )
                  BegStr = (FindStr + esr->LenStrSearchTmp);
               else
                  BegStr =  (FindStr++);

               if( esr->SetRegExp && FirstReplace == true && *StrSearchTmp_ProcSearch == '^' )
                  SetRegExpSearchStrTmp( esr, StrSearchTmp_ProcSearch, &esr->ei, 1 );

               FirstReplace = false;

               find = true;
               continue;
            }

            find = true;
            break;
         }

         //᫨   砫 ப '^' - ਬ ,    "\n\m"
         if( !esr->Replace && !esr->AllProc && repeat == false && esr->SetRegExp && find == false && *StrSearchTmp_ProcSearch == '^' ){
            SetRegExpSearchStrTmp( esr, StrSearchTmp_ProcSearch, &esr->ei, 1 );
            FindStr = BegStr;
            repeat  = true;
            continue;
         }      

         // 訡  ࠧ ப-  ॣᯠ
         if( esr->SetRegExp && esr->ErrRegExpReplace == 1 ){
            esr->AllProc = 0; // ⬥ ⮪ 
            break;
         }

      }

      if( esr->NumFindForReplace )//࠭塞 䠩
         StringBuff2File( esr );

      return find;
      
   }
   else return false;

}


//***************************************************************************
//  楤 믮 ।⠭ ᪠
//***************************************************************************
static void PreProcessSearch( ExtSearchReg *esr, int *SizeX, int *AddrHistory, int *AddrReplaceHistory, int *AddrMaskHistory ){

  if( !esr->SearchInFile ){
     //। ਭ   ᨬ  ࠧ  ।
     if( esr->ei.WindowSizeX > 80 ) *SizeX = esr->ei.WindowSizeX - BeforeLeft; 
     else *SizeX = DefSizeX;
  }
  else *SizeX = DefSizeX;
  //

  if( esr->LinkSystem == false ){ 
     *AddrHistory = (int)ExtHistoryName;
     if( AddrReplaceHistory ) *AddrReplaceHistory = (int)ExtReplaceHistoryName;
     if( AddrMaskHistory    ) *AddrMaskHistory    = (int)ExtMaskHistoryName;
  }
  else{
     *AddrHistory = (int)HistoryName;
     if( AddrReplaceHistory ) *AddrReplaceHistory = (int)ReplaceHistoryName;
     if( AddrMaskHistory    ) *AddrMaskHistory    = (int)MaskHistoryName;
  }

  //墠⨬ ᫮  ஬ ⮨
  if( !esr->SearchInFile && esr->PickUpWord ){                 
     int BegPos = -1;
     struct EditorGetString str;
     char CurWord[LenCurWord] = "";
     str.StringNumber = -1;// 祭 ⥪饩 ப
     ExtSearchInfo.EditorControl( ECTL_GETSTRING, &str );
     GetCurWord( esr, CurWord, str.StringText, str.StringLength, esr->ei.CurPos, &BegPos );
     if( *CurWord != '\0' ){

        if( esr->DN_Position && BegPos != -1 )//AV 02.12.99 ᯮ樮㥬 । 墠祭 ᫮
           SetEditorPosition( esr, esr->ei.CurLine, BegPos, 0, 0, esr->ReverseSearch );

        memset( (void*)esr->SearchStr, '\0', LenSearchStr );
        strncpy( esr->SearchStr, CurWord, LenSearchStr-1 );
     }
  }

  //墠⨬  ClipBoard
  if( !esr->SearchInFile && esr->PickUpClipBoard ){
     memset( (void*)esr->SearchStr, '\0', LenSearchStr );
     GetClipBoard( esr->SearchStr, LenSearchStr-1 );
     ConvertFromWinRus( esr->SearchStr, LenSearchStr );
  }
}

//***************************************************************************
//  楤 ⠥ registry    ஥
//***************************************************************************
void GetRegExtSearch( ExtSearchReg *esr ){

  if( !esr->SearchInFile )
     ExtSearchInfo.EditorControl( ECTL_GETINFO, &esr->ei );
  else{
     memset( &esr->ei, 0, sizeof(esr->ei) );           
     esr->CodeTableSearchInFile = GetRegKey(HKEY_CURRENT_USER,"","CodeTableSearchInFile", -1 );
     esr->SearchFromDir = GetRegKey(HKEY_CURRENT_USER,"","SearchFromDir", SIFKind_FromCurDir );
  }

  int BkGrSelect = GetRegKey(HKEY_CURRENT_USER,"","BkGrSelect", DefBkGrSelect );
  int ClrSelect  = GetRegKey(HKEY_CURRENT_USER,"","ClrSelect",  DefClrSelect  );

  Sel.Color = ClrSelect + BkGrSelect * 16;
  Sel.Set   = false;  

  esr->CaseSensitive = GetRegKey(HKEY_CURRENT_USER,"","CaseSensitive",false);
  esr->ReverseSearch = GetRegKey(HKEY_CURRENT_USER,"","ReverseSearch",false);
  esr->WordSearch    = GetRegKey(HKEY_CURRENT_USER,"","WordSearch"   ,false);
  esr->SetSelect     = GetRegKey(HKEY_CURRENT_USER,"","Select"       ,false);
  esr->SetRegExp     = GetRegKey(HKEY_CURRENT_USER,"","SetRegExp"    ,false);

  esr->UpSetRegExp   = GetRegKey(HKEY_CURRENT_USER,"","UpSetRegExp"  ,false);
  esr->CheckESC      = GetRegKey(HKEY_CURRENT_USER,"","CheckESC"     ,false);
  esr->NoSaveGlobal  = GetRegKey(HKEY_CURRENT_USER,"","NoSaveGlobal" ,false);
  esr->DN_Position   = GetRegKey(HKEY_CURRENT_USER,"","DN_Position"  ,false);
  esr->NoContinueReplace = GetRegKey(HKEY_CURRENT_USER,"","NoContinueReplace",false);
  esr->CheckEmptyReplace = GetRegKey(HKEY_CURRENT_USER,"","CheckEmptyReplace",false);

  esr->PickUpClipBoard = 0;

  //AV 17.11.99
  esr->AutoSearchInSelect = GetRegKey(HKEY_CURRENT_USER,"","AutoSearchInSelect" , false );

  esr->FromSearch = GetRegKey(HKEY_CURRENT_USER,"","FromSearch"   ,0);
  
  esr->PickUpWord = GetRegKey(HKEY_CURRENT_USER,"","PickUpWord",true);
  esr->LinkSystem = GetRegKey(HKEY_CURRENT_USER,"","LinkSystem"   ,true );
  esr->PutInClipBoard = GetRegKey(HKEY_CURRENT_USER,"","PutInClipBoard", false);

  if( esr->LinkSystem == false || esr->NoDialog ){ 
     GetRegKey(HKEY_CURRENT_USER,"","SearchStr",esr->SearchStr,"",LenSearchStr);
     GetRegKey(HKEY_CURRENT_USER,"","ReplaceStr",esr->ReplaceStr,"",LenSearchStr);
     GetRegKey(HKEY_CURRENT_USER,"","MaskStr",esr->MaskStr,"",LenSearchStr);
  }
  else{
     GetRegKey(HKEY_CURRENT_USER,"","SearchStr",esr->SearchStr,"",LenSearchStr);
     GetRegKey(HKEY_CURRENT_USER,"","ReplaceStr",esr->ReplaceStr,"",LenSearchStr);
     if( *esr->SearchStr ) 
        GetRegKey(HKEY_CURRENT_USER,"","Line0",esr->SearchStr,"",LenSearchStr,SearchTextRootKey);
     if( *esr->ReplaceStr )
        GetRegKey(HKEY_CURRENT_USER,"","Line0",esr->ReplaceStr,"",LenSearchStr,ReplaceTextRootKey);

     GetRegKey(HKEY_CURRENT_USER,"","Line0",esr->MaskStr,"",LenSearchStr,MaskTextRootKey);
  }

  //AV 17.01.00 뤥塞 ⠭묨 ।⢠  ColorAPI
  esr->SelectFAR =  !GetRegKey( HKEY_CURRENT_USER,"","KindSelect" , 0 ) ? 1 : 0;

  esr->ErrRegExpReplace = 0;
  esr->ErrRegExpSearch  = 0;
}

//***************************************************************************
//  楤  registry 
//***************************************************************************
void SetRegExtSearch( ExtSearchReg *esr ){

  if( !esr->SearchInFile ){
     int FromSearch;
   
     if( esr->NoSaveGlobal && esr->FromSearch == 1 )//ਠ ᪠ - " ᥬ 䠩"  ࠭塞!
        FromSearch = 0;
     else 
        FromSearch = esr->FromSearch;

     SetRegKey(HKEY_CURRENT_USER,"","FromSearch",FromSearch);

     SetRegKey(HKEY_CURRENT_USER,"","PickUpWord"   , esr->PickUpWord   );
     SetRegKey(HKEY_CURRENT_USER,"","PutInClipBoard", esr->PutInClipBoard );
     SetRegKey(HKEY_CURRENT_USER,"","Select"       , esr->SetSelect    );
  }else{
     SetRegKey(HKEY_CURRENT_USER,"","CodeTableSearchInFile",esr->CodeTableSearchInFile);
     SetRegKey(HKEY_CURRENT_USER,"","SearchFromDir",esr->SearchFromDir);
  }


  SetRegKey(HKEY_CURRENT_USER,"","WordSearch"   , esr->WordSearch   );
  SetRegKey(HKEY_CURRENT_USER,"","CaseSensitive", esr->CaseSensitive);
  SetRegKey(HKEY_CURRENT_USER,"","ReverseSearch", esr->ReverseSearch);

  SetRegKey(HKEY_CURRENT_USER,"","LinkSystem"   , esr->LinkSystem   );

  SetRegKey(HKEY_CURRENT_USER,"","SetRegExp"    , esr->SetRegExp    );
}      

//***************************************************************************
//AV 09.12.99   ଠ஢ ६  ஢ ப ᪠ 
//***************************************************************************
static void SetSearchStr_Buffers( ExtSearchReg *esr ){
  //  㭪樨 ᥣ  뢠     ⮩ ।
  SetSearchStrTmp( esr, esr->SearchStr );

  if( esr->SetRegExp )
     SetRegExpSearchStrTmp( esr, StrSearchTmp_ProcSearch, &esr->ei, 0 );
  //
}



//***************************************************************************
//  䥩᭠  ᪠
//***************************************************************************
static void RunSearch( ExtSearchReg *esr, int Mode )
{

  int SizeX, AddrHistory;

  GetRegExtSearch( esr ); 

  if( Mode ){

     esr->FromSearch = 0;//ᥣ 饬  ⥪饩 樨

     if( Mode == 1 || Mode == 3){ 
        esr->PickUpWord = 1; 
        esr->WordSearch = 1;
        if( Mode == 3 ) esr->ReverseSearch = 1; 
        else esr->ReverseSearch = 0; 
     }
     if( Mode == 2 || Mode == 4 ){
        esr->PickUpClipBoard = 1;
        if( Mode == 4 ) esr->ReverseSearch = 1; 
        else esr->ReverseSearch = 0; 
     }

     esr->CaseSensitive = 1;
     esr->SetRegExp = 0;
  }

  //AV 16.12.99 ᬥ饭   
  int OffsetDn = 0, OffsetUp = 0;
  if( esr->UpSetRegExp ){
     OffsetDn = CHECKBOX_MOVE_DN;
     OffsetUp = CHECKBOX_MOVE_UP;
  }

  PreProcessSearch( esr, &SizeX, &AddrHistory, NULL, NULL );       


  int ExitCode;
  char StrTmp[LenSearchStr];

  if( !Mode ){
     //樠   ᪠
     struct InitDialogItem InitItems[]={
        {DI_DOUBLEBOX,WidthUnderSide,1,SizeX-WidthUnderSide-1,BottomSearchDialog-WidthUnder,0,0,0,0,(char *)MExtSearchTitle},
        {DI_TEXT,WidthUnderSide+2,2,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrForSearch},
        {DI_EDIT,WidthUnderSide+2,3,SizeX-WidthUnderSide-3,0,true,AddrHistory,DIF_HISTORY,0, esr->SearchStr },
        {DI_TEXT,WidthUnderSide+2,4,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
        {DI_CHECKBOX,WidthUnderSide+2,5,0,0,0,0,0,0,(char *)MCaseSensitive},
        {DI_CHECKBOX,WidthUnderSide+2,6,0,0,0,0,0,0,(char *)MWordSearch},
        {DI_CHECKBOX,WidthUnderSide+2,7,0,0,0,0,0,0,(char *)MReverseSearch},
        {DI_CHECKBOX,WidthUnderSide+2,8,0,0,0,0,0,0,(char *)MSetRegExp},
        {DI_CHECKBOX,WidthUnderSide+2+25,5,0,0,0,0,0,0,(char *)MPickUpWord},
        {DI_CHECKBOX,WidthUnderSide+2+25,6,0,0,0,0,0,0,(char *)MSelect},    
        {DI_CHECKBOX,WidthUnderSide+2+25,7,0,0,0,0,0,0,(char *)MLinkSystem},
        {DI_CHECKBOX,WidthUnderSide+2+25,8,0,0,0,0,0,0,(char *)MPutInClipBoard},
   
        {DI_TEXT,WidthUnderSide+2,9,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
        {DI_RADIOBUTTON, WidthUnderSide+2,10,0,0,0,0,DIF_GROUP,0,(char *)MFromCursor},         
        {DI_RADIOBUTTON, WidthUnderSide+2,11,0,0,0,0,0,0,(char *)MGlobal},         
        {DI_RADIOBUTTON, WidthUnderSide+2,12,0,0,0,0,0,0,(char *)MSelText},
        {DI_TEXT,WidthUnderSide+2,13,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
   
        {DI_BUTTON,0,BottomSearchDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,1,(char *)MSearch},
        {DI_BUTTON,0,BottomSearchDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,0,(char *)MCount},
        {DI_BUTTON,0,BottomSearchDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,0,(char *)MCancel}
     };
   
     //믮  ᪠
     struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
     InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]), esr->UpSetRegExp, SearchTypeDialog );
   
     DialogItems[NDI_CaseSensitive+OffsetDn].Selected = esr->CaseSensitive;
     DialogItems[NDI_ReverseSearch+OffsetDn].Selected = esr->ReverseSearch;
     DialogItems[NDI_WordSearch   +OffsetDn].Selected = esr->WordSearch;
     DialogItems[NDI_PickUpWord   ].Selected = esr->PickUpWord;
     DialogItems[NDI_Select       ].Selected = esr->SetSelect;
     DialogItems[NDI_LinkSystem   ].Selected = esr->LinkSystem;
     DialogItems[NDI_PutInClipBoard].Selected = esr->PutInClipBoard;
     DialogItems[NDI_SetRegExp    -OffsetUp].Selected = esr->SetRegExp;
   
     DialogItems[NDI_FromCursor + esr->FromSearch].Selected = 1;
   
     ExitCode=ExtSearchInfo.Dialog(ExtSearchInfo.ModuleNumber,-1,-1, SizeX,BottomSearchDialog,Help_ExtSearch,DialogItems,
                              sizeof(DialogItems)/sizeof(DialogItems[0]));
   
     esr->CaseSensitive = DialogItems[NDI_CaseSensitive+OffsetDn].Selected;
     esr->ReverseSearch = DialogItems[NDI_ReverseSearch+OffsetDn].Selected;
     esr->WordSearch    = DialogItems[NDI_WordSearch   +OffsetDn].Selected;
     esr->SetSelect     = DialogItems[NDI_Select       ].Selected;
     esr->PickUpWord    = DialogItems[NDI_PickUpWord   ].Selected;
     esr->LinkSystem    = DialogItems[NDI_LinkSystem   ].Selected;
     esr->PutInClipBoard= DialogItems[NDI_PutInClipBoard].Selected;
     esr->SetRegExp     = DialogItems[NDI_SetRegExp    -OffsetUp].Selected;
   
     if( DialogItems[NDI_FromCursor].Selected      ) esr->FromSearch = 0;
     else if( DialogItems[NDI_Global].Selected     ) esr->FromSearch = NDI_Global - NDI_FromCursor;
     else if( DialogItems[NDI_SelText].Selected    ) esr->FromSearch = NDI_SelText - NDI_FromCursor;
     else esr->FromSearch = 0;

     strncpy( StrTmp, DialogItems[NDI_EditSearch].Data, LenSearchStr );
  }
  else{
     ExitCode = NDI_ButtonSearch;
     strncpy( StrTmp, esr->SearchStr, LenSearchStr );
  }

  if ( ExitCode == NDI_ButtonSearch || ExitCode == NDI_ButtonCount ){ // ""  ""

     if( !Mode ) SetRegExtSearch( esr ); 

     esr->WasReplace = 0; 

     strncpy( esr->SearchStr, StrTmp, LenSearchStr );
     SetRegKey(HKEY_CURRENT_USER,"","SearchStr"    ,esr->SearchStr    );

     SetSearchStr_Buffers( esr );//AV 09.12.99

     esr->NumFindForReplace = 0;
     esr->NumCount = 0;
     esr->AllProc = 0;//AV 10.12.99

     esr->Replace = 0;
     esr->ContinueSearch = 0;

     if(ExitCode == NDI_ButtonSearch)
        ProcSearch( esr );  
     else{
        int BegPos  = esr->ei.CurPos;
        int BegLine = esr->ei.CurLine;
        CountSearch( esr );
        SetEditorPosition( esr, BegLine, BegPos, 0, 0, esr->ReverseSearch );
     }
  }
}

struct ExtFileInfo{
   char Path[1024];
   char IsDir;
}ExtFileInfo;


static char *_MExtSearchTitle, *_MProcSearch, *_MProcFinishSearch;
static char _Find[256];

//易⥫쭮 맢 ।  ᯮ짮  MessInfoSearch
static void InitMessInfoSearch( void ){
   *_Find = '\0';
   strcpy( _Find, GetMsg( MFindInfo ) ); strcat( _Find, " %ld  " );
   //strcat( _Find, GetMsg( MProcInfo ) ); strcat( _Find, " %ld" );
   strcat( _Find, GetMsg( MProcSearch ) ); 

   _MExtSearchTitle   = GetMsg(MExtSearchTitle);
   _MProcSearch       = GetMsg(MProcSearch);
   _MProcFinishSearch = GetMsg(MProcFinishSearch);
}

//ଠ樮 ᮮ饭  ६ ᪠  䠩 ( ப   १⠬)
#pragma argsused
static void MessInfoSearch( ExtSearchReg *esr, int NumFind, int NumProc, int Finish ){
   if( !Finish )
      sprintf( esr->MenuBottom, _Find, NumFind/*, NumProc*/ );
   else
      sprintf( esr->MenuBottom, _MProcFinishSearch, NumFind );
}


//struct ftime {
//  unsigned ft_tsec  : 5;  /* Two seconds */
//  unsigned ft_min   : 6;  /* Minutes */
//  unsigned ft_hour  : 5;  /* Hours */
//  unsigned ft_day   : 5;  /* Days */
//  unsigned ft_month : 4;  /* Months */
//  unsigned ft_year  : 7;  /* Year - 1980 */
//}; 

inline void SetMenuItemFile( struct FarMenuItem *mi, struct ExtFileInfo *fi, char *FilePath, struct ffblk *ff ){
   char fSize[19];
   ftime *t = (ftime *)&ff->ff_ftime;
   unsigned year = t->ft_year;
   if( year < 20 ) year += 80;
   else year -= 20;

   sprintf( mi->Text, "%3s%-49s   %02d.%02d.%02d   %02d:%02d", "   ", ff->ff_name, t->ft_day, t->ft_month, year, t->ft_hour, t->ft_min ); 
   strncpy( fi->Path, FilePath, 1024 ); 
   fi->IsDir = 0;
}

inline void SetMenuItemDir( struct FarMenuItem *mi, struct ExtFileInfo *fi, char *Path ){
   sprintf( mi->Text, "%-70s", Path );  
   strncpy( fi->Path, Path, 1024 ); 
   fi->IsDir = 1;
}

inline void SetMenuItemDelim( struct FarMenuItem *mi, struct ExtFileInfo *fi ){
   memset( (void*)mi->Text, ' ', 70 );  
   strcpy( fi->Path, "" ); 
   fi->IsDir = 2;
}

//஢ઠ:      - ff_name 뤥
static bool IsSelItem( ExtSearchReg *esr, char *ff_name ){
   struct PluginPanelItem *ppi;
   for( int i = 0; i < esr->SelItemsNumber; i++ ){
      ppi = (esr->SelItems + i);
      //if( ppi->FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ){
         if( !strcmpi( ff_name, ppi->FindData.cFileName ) )  return true;
      //}
   }
   return false;
}

static void ProcFiles( ExtSearchReg *esr, char *Path, int rec ){

  int  SetDir = 0;                          
  struct ffblk  ff;//ଠ  ⥪饬 "" 䠩
  char TmpPath[MAXPATH];
  DWORD lpcWritten = 0;

  strcpy( TmpPath, Path );
  strcat( TmpPath, "\\" );
  strcat( TmpPath, /*esr->MaskStr*/"*.*" ); //஢ઠ  ᪨ 믮  CheckMasks

  int loop;

//  if( rec /*|| esr->SearchFromDir != SIFKind_SelDir*/ ){

     loop = findfirst( TmpPath, &ff, FA_DIREC );
   
     while( !loop ) {
  
       if( esr->ExitThread ){ 
          FreeMasks( esr );
          esr->ExitThread = 0; 
          _endthread();   
          /*ExitThread( 0 ); */
          /*if( CloseHandle( esr->HandleProcFiles ) == true )
             esr->HandleProcFiles = NULL;*/
       }
 
       // ய᪠ ᠬ ⠫   㦥 ⠫
       if( !(ff.ff_attrib & FA_LABEL) && strcmp( ff.ff_name, "." ) && strcmp( ff.ff_name, ".." ) ){
   
          if( !(ff.ff_attrib & FA_DIREC) && !esr->OnlySearchFile ){ 

             //᫨  孥 ஢, ஢ઠ  뤥 䠩
             if( !rec && esr->SearchFromDir == SIFKind_SelDir && IsSelItem( esr, ff.ff_name ) == false ){
                loop = findnext( &ff );            
                continue;
             }
   
             esr->fNumProc++;
             MessInfoSearch( esr, esr->fNumFindFiles, esr->fNumProc, 0 );
   
             //if( esr->InMenu && esr->ProcSendKey <= LEVEL_PROCSENDKEY ){
             //   WriteConsoleInput( GetStdHandle(STD_INPUT_HANDLE), &esr->rec, 1, &lpcWritten );             
             //   esr->ProcSendKey++;
             //}
   
             if( CheckMasks( esr, ff.ff_name) ){  
     
                  strcpy( esr->FilePath, Path );
                  strcat( esr->FilePath, "\\" );
                  strcat( esr->FilePath, ff.ff_name );
     
                  //稢 䠩, ⮫쪮 ᫨ ப ᪠  
                  if( *esr->SearchStr && File2StringBuff( esr ) == false ){
                     loop = findnext( &ff );
                     continue; //ய᪠  䠩, த ࠡ :)
                  }
                    
                  if( (esr->ExitCode == NFI_ButtonSearch) || (esr->Replace && esr->ExitCode == NRFI_ButtonReplace) ){
                     if( !*esr->SearchStr || ProcFileSearch( esr ) ){
   
                        esr->fNumFindFiles++;
                        MessInfoSearch( esr, esr->fNumFindFiles, esr->fNumProc, 0 );

                        //if( esr->InMenu && esr->ProcSendKey <= LEVEL_PROCSENDKEY ){
                        //   WriteConsoleInput( GetStdHandle(STD_INPUT_HANDLE), &esr->rec, 1, &lpcWritten );
                        //   esr->ProcSendKey++;
                        //}
   
                        // ᨢ    १⠬
                        if( !SetDir ){
                           if( esr->fNumFind > (BEGSIZE_SEARCH_RES * esr->NumBlocks ) ){
                             // SuspendThread( esr->HandleCurProc );
                              esr->Realloc = 1;
                              WriteConsoleInput( GetStdHandle(STD_INPUT_HANDLE), &esr->rec, 1, &lpcWritten );
                              esr->ProcSendKey = 0;
                              while( esr->InMenu ){ /**/};
                              esr->_mi = (struct FarMenuItem*)HeapReAlloc( esr->Heap, 0, esr->_mi, sizeof(struct FarMenuItem) * (esr->fNumFind+BEGSIZE_SEARCH_RES) );
                              esr->_fi = (struct ExtFileInfo*)HeapReAlloc( esr->Heap, 0, esr->_fi, sizeof(struct ExtFileInfo) * (esr->fNumFind+BEGSIZE_SEARCH_RES) );                        
                              esr->NumBlocks++;
                              memset( esr->_mi+esr->fNumFind, 0, sizeof(struct FarMenuItem) * BEGSIZE_SEARCH_RES );   
                              esr->Realloc = 0;
                             // ResumeThread( esr->HandleCurProc );
                           }
                           struct FarMenuItem *cur_mi = esr->_mi+esr->fNumFind; 
                           struct ExtFileInfo *cur_fi = esr->_fi+esr->fNumFind;
   
                           if( esr->fNumFind ){
                              SetMenuItemDelim( cur_mi, cur_fi );
                              SetMenuItemDir( cur_mi+1, cur_fi+1, Path );
                              SetMenuItemFile( cur_mi+2, cur_fi+2, esr->FilePath, &ff );    
                              (esr->fNumFind)+=3;        
                           }else{
                              SetMenuItemDir( cur_mi, cur_fi, Path );
                              SetMenuItemFile( cur_mi+1, cur_fi+1, esr->FilePath, &ff );    
                              (esr->fNumFind)+=2;        
                           }                        
                           SetDir = 1;
                        }else{ 
                           if( esr->fNumFind > (BEGSIZE_SEARCH_RES * esr->NumBlocks ) ){   
                              //SuspendThread( esr->HandleCurProc );                                                                
                              esr->Realloc = 1;
                              WriteConsoleInput( GetStdHandle(STD_INPUT_HANDLE), &esr->rec, 1, &lpcWritten );
                              esr->ProcSendKey = 0;
                              while( esr->InMenu ) { /**/ };
                              esr->_mi = (struct FarMenuItem*)HeapReAlloc( esr->Heap, 0, esr->_mi, sizeof(struct FarMenuItem) * (esr->fNumFind+BEGSIZE_SEARCH_RES) );
                              esr->_fi = (struct ExtFileInfo*)HeapReAlloc( esr->Heap, 0, esr->_fi, sizeof(struct ExtFileInfo) * (esr->fNumFind+BEGSIZE_SEARCH_RES) );
                              esr->NumBlocks++;
                              memset( esr->_mi+esr->fNumFind, 0, sizeof(struct FarMenuItem) * BEGSIZE_SEARCH_RES );      
                              esr->Realloc = 0;
                              //ResumeThread( esr->HandleCurProc );
                           }   
                           struct FarMenuItem *cur_mi = esr->_mi+esr->fNumFind; 
                           struct ExtFileInfo *cur_fi = esr->_fi+esr->fNumFind; 
   
                           SetMenuItemFile( cur_mi, cur_fi, esr->FilePath, &ff );
                           (esr->fNumFind)++;
                        }
                        //if( esr->InMenu && esr->ProcSendKey <= LEVEL_PROCSENDKEY ){
                        //   WriteConsoleInput( GetStdHandle(STD_INPUT_HANDLE), &esr->rec, 1, &lpcWritten );
                        //   esr->ProcSendKey++;
                        //}
                        if( esr->InMenu ){
                           WriteConsoleInput( GetStdHandle(STD_INPUT_HANDLE), &esr->rec, 1, &lpcWritten );
                           esr->ProcSendKey = 0;
                        }
                     }
                  }
             }     
          }else if( !(ff.ff_attrib & FA_DIREC) && esr->OnlySearchFile ){
              if( stricmp( esr->OnlySearchFileName, ff.ff_name ) == 0 ){
                 strcpy( esr->OnlySearchFileName, Path );
                 strcat( esr->OnlySearchFileName, "\\" );
                 strcat( esr->OnlySearchFileName, ff.ff_name );
                 esr->OnlySearchFileTrue = 1;
                 return; //諨 䠩 - 室
              }
          }
       }

       //᫨    䠩, 뢠 稪    䠩
       if( esr->Replace )  esr->NumFindForReplace = 0;

       loop = findnext( &ff );
     }
/*  }*/


  loop = findfirst( TmpPath, &ff, FA_DIREC );


  while( !loop ) {

    if( esr->ExitThread ){ 
       FreeMasks( esr );
       esr->ExitThread = 0; 
       _endthread();       
       /*ExitThread( 0 );  */
       /*if( CloseHandle( esr->HandleProcFiles ) == true )
          esr->HandleProcFiles = NULL;*/
    }

    //if( esr->InMenu && esr->ProcSendKey <= LEVEL_PROCSENDKEY ){
    //   WriteConsoleInput( GetStdHandle(STD_INPUT_HANDLE), &esr->rec, 1, &lpcWritten );
    //   esr->ProcSendKey++;
    //}

    // ய᪠ ᠬ ⠫   㦥 ⠫
    if( !(ff.ff_attrib & FA_LABEL) && strcmp( ff.ff_name, "." ) && strcmp( ff.ff_name, ".." ) ){

       if( (ff.ff_attrib & FA_DIREC) && (esr->SearchFromDir != SIFKind_OnlyCurDir) ){
         strcpy( TmpPath, Path );
         strcat( TmpPath, "\\" );
         strcat( TmpPath, ff.ff_name );

         //᫨  孥 ஢, ஢ઠ   ᪠  뤥 ⠫
         if( !rec && esr->SearchFromDir == SIFKind_SelDir && IsSelItem( esr, ff.ff_name ) == false ){
            loop = findnext( &ff );            
            continue;
         }

         ProcFiles( esr, TmpPath, 1 );//४ᨢ 맮
       }
    }

    loop = findnext( &ff );
  }

  if( !esr->OnlySearchFile )
     //ᮡ饭     襭 ᪠
     if( !rec ){

        MessInfoSearch( esr, esr->fNumFindFiles, esr->fNumProc, 1 );

        if( esr->InMenu  )
           WriteConsoleInput( GetStdHandle(STD_INPUT_HANDLE), &esr->rec, 1, &lpcWritten );

     }
}


struct ParmThreadFunc{
 char Path[MAXPATH];
 ExtSearchReg *esr;
}ptf;

#pragma argsused
static void ThreadFuncProcFiles( void *p ) { 

   if( ESEARCH_RUN_PlatformID != VER_PLATFORM_WIN32_NT ){
      DWORD lpcWritten = 0;
      ptf.esr->rec.Event.MouseEvent.dwEventFlags = MOUSE_MOVED;         
      WriteConsoleInput( GetStdHandle(STD_INPUT_HANDLE), &ptf.esr->rec, 1, &lpcWritten ); 
      ptf.esr->rec.Event.MouseEvent.dwEventFlags = 0;
   }

   ptf.esr->AlreadyExitThread = 0;
   FillMasks( ptf.esr );
   ProcFiles( ptf.esr, ptf.Path, 0 );
   FreeMasks( ptf.esr );

   ptf.esr->HandleProcFiles = NULL;
   ptf.esr->AlreadyExitThread = 1;
   return;
} 

static HANDLE MakeThreadProcFiles( ExtSearchReg *esr, char *Path  ){
   DWORD dwThreadId;
   HANDLE h = NULL;

   strcpy( ptf.Path, Path );
   ptf.esr = esr;
   /*HANDLE h = CreateThread( 
        NULL, 
        0,    
        (LPTHREAD_START_ROUTINE) ThreadFuncProcFiles,
        NULL,                   
        NULL,                           
        &dwThreadId); */
    
    
   if( ESEARCH_RUN_PlatformID == VER_PLATFORM_WIN32_NT ){
      SECURITY_ATTRIBUTES     sa = 
                       {
                               sizeof(SECURITY_ATTRIBUTES),    // structure size
                               0,                              // No security descriptor
                               TRUE,                           // Thread handle is inheritable

                       };

       h = (HANDLE)_beginthreadNT(
                                           ThreadFuncProcFiles,    // Thread starting address
                                           4096,                   // Thread stack size
                                           NULL,                   // Thread start argument
                                           &sa,                    // Thread security
                                           0,                      // Create in suspended state
                                           &dwThreadId); 
   }else{
       _beginthread( ThreadFuncProcFiles,    // Thread starting address
                     4096,                   // Thread stack size
                     NULL );                 // Thread start argument

   }

   if( ESEARCH_RUN_PlatformID != VER_PLATFORM_WIN32_NT ){
      DWORD lpcWritten = 0;
      ptf.esr->rec.Event.MouseEvent.dwEventFlags = MOUSE_MOVED;         
      WriteConsoleInput( GetStdHandle(STD_INPUT_HANDLE), &ptf.esr->rec, 1, &lpcWritten ); 
      ptf.esr->rec.Event.MouseEvent.dwEventFlags = 0;
   }

   return h;
}


static int GetNumItemInPanel( char *FileName, int *TopPanelItem ){
  struct PanelInfo pi;
  struct PluginPanelItem *ppi;
  ExtSearchInfo.Control( INVALID_HANDLE_VALUE, FCTL_GETPANELINFO, &pi );
  if( TopPanelItem ) *TopPanelItem = pi.TopPanelItem;

  for( int i = 0; i < pi.ItemsNumber; i++ ){  
     ppi = pi.PanelItems + i;
     if( !(ppi->FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
         && !strcmp( ppi->FindData.cFileName, FileName ) )
          return i;
  }
  return 0;
}

//᭨ ਧ 뤥    ᨢ ⮢ 
//static void ClearMenuItem( struct FarMenuItem *mi, int CurNum, int Offset, int MaxNum ){
//   struct FarMenuItem *cur_mi = mi+CurNum;
//   for( int i = 0; i <= Offset; i++ ){
//      if( (CurNum - i) >=0      ) (cur_mi-i)->Selected = false;
//      if( (CurNum + i) < MaxNum ) (cur_mi+i)->Selected = false;
//   }
//}

static void PreProcessMenu_Files( ExtSearchReg *esr, int Replace ){
  SetRegExtSearch( esr ); 

  // ᫥襣 뫠 ᮡ - ⨥   thread(᪠  䠩)
  // ⮡ ᮢ뢠   १⠬ ᪠
  DWORD  lpcRead = 0;
  ReadConsoleInput(
    GetStdHandle(STD_INPUT_HANDLE),
    &esr->rec,
    1,
    &lpcRead 
  ); 
  esr->rec.EventType = KEY_EVENT;
  esr->rec.Event.KeyEvent.wVirtualKeyCode = VK_F2;
  esr->rec.Event.KeyEvent.bKeyDown = true;
  //

  SetSearchStr_Buffers( esr );

  esr->WasReplace = 0; 

  esr->NumFindForReplace = 0;
  esr->NumCount = 0;
  esr->AllProc = 0;

  esr->Replace = Replace;
  esr->ContinueSearch = 0;

  esr->fNumFind = 0; esr->fNumProc = 0; esr->fAllNumCount = 0; esr->fNumFindFiles = 0;

  //ᮮ饭  ६ ᪠
  InitMessInfoSearch();
  MessInfoSearch( esr, esr->fNumFindFiles, esr->fNumProc, 0 );

  esr->NumBlocks = 1; //-  , 뤥  १ ᪠

  esr->_mi = (struct FarMenuItem *)HeapAlloc( esr->Heap, 0, sizeof(struct FarMenuItem) * BEGSIZE_SEARCH_RES );
  esr->_fi = (struct ExtFileInfo *)HeapAlloc( esr->Heap, 0, sizeof(struct ExtFileInfo) * BEGSIZE_SEARCH_RES );

  memset( esr->_mi, 0, sizeof(struct FarMenuItem) * BEGSIZE_SEARCH_RES );
  memset( esr->_mi->Text, ' ', 70 );  

  struct PanelInfo   pi;
  ExtSearchInfo.Control( INVALID_HANDLE_VALUE, FCTL_GETPANELINFO, (void*)&pi );
  strncpy( esr->BegPath, pi.CurDir, MAXPATH-1 );

  //࠭ ଠ  뤥   
  if( esr->SearchFromDir == SIFKind_SelDir ){
     esr->SelItemsNumber = pi.SelectedItemsNumber;
     esr->SelItems = (struct PluginPanelItem *)HeapAlloc( esr->Heap, 0, sizeof(struct PluginPanelItem) * esr->SelItemsNumber );
     memcpy( esr->SelItems, pi.SelectedItems, sizeof(struct PluginPanelItem) * esr->SelItemsNumber );
  }

  esr->HandleProcFiles = NULL;

  esr->ExitThread = 0;
}

/***************************************************************************/
/*   楤 ࠡ⪨   ᪥\  䠩 +   䠩*/
/***************************************************************************/
#pragma argsused
static void ProcessMenu_Files( ExtSearchReg *esr, int Replace ) {

  esr->Realloc = 0;
  esr->ProcSendKey = 1;

  esr->HandleProcFiles = MakeThreadProcFiles( esr, esr->BegPath ); //४ᨢ 室        

  int Num = 0, PrevNum = 0;

  int BreakKeys[4], BreakKeysNum = -1;
  BreakKeys[0] = VK_F3;
  BreakKeys[1] = VK_F4;
  BreakKeys[2] = VK_F2;
  BreakKeys[3] = 0;

  char fPath[MAXPATH];
  int  IsDir; // l_fNumFind, Suspend = 0
  //struct FarMenuItem *l_mi;*/           

  while( Num >= 0 ){

     while( esr->Realloc ) {/**/}; //⨬   ᪠  䠩  ந Realloc

      esr->InMenu = 1;
      IsDir = 0;

      (esr->_mi+PrevNum)->Selected = false;
      (esr->_mi+Num)->Selected = true;
      PrevNum = Num;

      Num = ExtSearchInfo.Menu(
       ExtSearchInfo.ModuleNumber,
       -1, -1, 25,
       FMENU_AUTOHIGHLIGHT,
       GetMsg( MExtSearchTitle ),
       esr->MenuBottom,
       "Contents",
       BreakKeys,
       &BreakKeysNum,
       esr->_mi,///l_mi
       esr->fNumFind > 25 ? esr->fNumFind : 25
      );  //l_fNumFind

      if( Num >= 0 && BreakKeysNum != 2 ){ //᫨ - ࠫ    ᮢ

         IsDir  = (esr->_fi+Num)->IsDir;
         strcpy( fPath, (esr->_fi+Num)->Path );
         if( IsDir == 2 ) continue; //ࠧ⥫  ᮡ⨥ ᮢ 
         if( BreakKeysNum <= 1 && Num >= esr->fNumFind ) continue;//஡ᨬ   

      }

      if( BreakKeysNum == 2 ){
         esr->ProcSendKey = 1;
         continue;
      }

      esr->InMenu = 0;

      if( Num >= 0 ){

         if( !IsDir && BreakKeysNum != -1 ){

            if( BreakKeysNum == 1 ){  //F4 - ।஢ 

               FlushConsoleInputBuffer( GetStdHandle(STD_INPUT_HANDLE) );

               ExtSearchInfo.Editor(
                fPath,
                 NULL,                                
                 0,
                 0,
                 -1,
                 -1,
                 EF_NONMODAL,                                     
                 0,
                 0
               );
            }
            else if( BreakKeysNum == 0 ){ //F3 - ᬮ

               FlushConsoleInputBuffer( GetStdHandle(STD_INPUT_HANDLE) );

               ExtSearchInfo.Viewer (
                 fPath,
                 NULL,
                 0,
                 0,
                 -1,
                 -1,
                 VF_NONMODAL
                  ); 
            }
         }
         else if( BreakKeysNum == -1 ){ //Enter - 室  ४                                     

            //뢠  ᮫ 
            FlushConsoleInputBuffer( GetStdHandle(STD_INPUT_HANDLE) );

            char Path[MAXPATH], FileName[MAXPATH];
            memset( Path, 0, MAXPATH );
            memset( FileName, 0, MAXPATH );
            if( !IsDir ){
               char *ptr = fPath, *save = NULL;
               while( (ptr = strstr( ptr, "\\" )) != NULL ){
                  save = ptr;
                  ptr++;
               }
               if( save ){
                  strncpy( Path, fPath, save - fPath );
                  strcpy( FileName, save+1 );
               }else{
                  strcpy( Path, fPath );
                  strcpy( FileName, fPath );
               }
            }else strcpy( Path, fPath ); 
               
            esr->SetDir = 1;

            ExtSearchInfo.Control( INVALID_HANDLE_VALUE, FCTL_SETPANELDIR, Path );
            if( IsDir )   ExtSearchInfo.Control( INVALID_HANDLE_VALUE, FCTL_REDRAWPANEL, NULL );
            else{
               struct PanelRedrawInfo pri;
               pri.CurrentItem  = GetNumItemInPanel( FileName, &pri.TopPanelItem );
               pri.TopPanelItem = 0;
               ExtSearchInfo.Control( INVALID_HANDLE_VALUE, FCTL_REDRAWPANEL, &pri );
               esr->SetDir = 0;
            }  
            break;
         }
      }
  }          

  esr->ExitThread = 1;

  if( ESEARCH_RUN_PlatformID == VER_PLATFORM_WIN32_NT ){

     WaitForSingleObject(  esr->HandleProcFiles,    // The object to wait for
                           INFINITE);               // No timeout
     //      Close all of the thread handles.
     if(esr->HandleProcFiles) CloseHandle(esr->HandleProcFiles);

  }else{// ᫨   訫, ⨬     ᪠  䠩
     while( esr->ExitThread && !esr->AlreadyExitThread ){/**/}; 
  }
      
  if( esr->_mi ){ HeapFree( esr->Heap, 0, esr->_mi ); esr->_mi = NULL; }
  if( esr->_fi ){ HeapFree( esr->Heap, 0, esr->_fi ); esr->_fi = NULL; }

  FlushConsoleInputBuffer( GetStdHandle(STD_INPUT_HANDLE) );
}

//***************************************************************************
//  䥩᭠  ᪠  䠩
//***************************************************************************
static void RunSearchInFile( ExtSearchReg *esr )
{

  for( ;; ){
     int SizeX, AddrHistory, AddrMaskHistory;
   
     GetRegExtSearch( esr ); 
   
     //AV 16.12.99 ᬥ饭   
     int OffsetDn = 0, OffsetUp = 0;
     if( esr->UpSetRegExp ){
        OffsetDn = CHECKBOX_MOVE_DN;
        OffsetUp = CHECKBOX_MOVE_UP - 1;
     }
   
    PreProcessSearch( esr, &SizeX, &AddrHistory, NULL, &AddrMaskHistory );       
   
    char TableName[53];
    memset( (void*)TableName, 0, 53 );
    *TableName = '[';
    GetTableName( esr, esr->CodeTableSearchInFile, TableName+1, 50 );
    *(TableName+strlen(TableName)) = ']';

     //樠   ᪠
     struct InitDialogItem InitItems[]={
        {DI_DOUBLEBOX,WidthUnderSide,1,SizeX-WidthUnderSide-1,4,0,0,0,0,""},
        {DI_DOUBLEBOX,WidthUnderSide,1,SizeX-WidthUnderSide-1,11,0,0,0,0,""},
        {DI_DOUBLEBOX,WidthUnderSide,1,SizeX-WidthUnderSide-1,BottomSearchInFileDialog-WidthUnder,0,0,0,0,(char *)MExtSearchTitle},
        {DI_TEXT,WidthUnderSide,4,0,0,0,0,DIF_BOXCOLOR,0,""},                 
        {DI_TEXT,SizeX-WidthUnderSide-1,4,0,0,0,0,DIF_BOXCOLOR,0,""},
        {DI_TEXT,WidthUnderSide+2,2,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrForMask},
        {DI_EDIT,WidthUnderSide+2,3,SizeX-WidthUnderSide-3,0,true,AddrMaskHistory,DIF_HISTORY,0, esr->MaskStr },
        {DI_TEXT,WidthUnderSide+2,5,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrForSearch},
        {DI_TEXT,WidthUnderSide+2+12,5,0,0,0,0,DIF_BOXCOLOR,0,(char *)TableName},
        {DI_EDIT,WidthUnderSide+2,6,SizeX-WidthUnderSide-3,0,0,AddrHistory,DIF_HISTORY,0, esr->SearchStr },
        {DI_TEXT,WidthUnderSide+2,7,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
        {DI_CHECKBOX,WidthUnderSide+2,8,0,0,0,0,0,0,(char *)MCaseSensitive},
        {DI_CHECKBOX,WidthUnderSide+2,9,0,0,0,0,0,0,(char *)MWordSearch},
        {DI_CHECKBOX,WidthUnderSide+2,10,0,0,0,0,0,0,(char *)MSetRegExp},
        {DI_CHECKBOX,WidthUnderSide+2+25,8,0,0,0,0,0,0,(char *)MLinkSystem},
   
        {DI_TEXT,WidthUnderSide,11,0,0,0,0,DIF_BOXCOLOR,0,""},                 
        {DI_TEXT,SizeX-WidthUnderSide-1,11,0,0,0,0,DIF_BOXCOLOR,0,""},
        {DI_RADIOBUTTON, WidthUnderSide+2,12,0,0,0,0,DIF_GROUP,0,(char *)MFromCurDir},         
        {DI_RADIOBUTTON, WidthUnderSide+2,13,0,0,0,0,0,0,(char *)MOnlyCurDir},         
        {DI_RADIOBUTTON, WidthUnderSide+2,14,0,0,0,0,0,0,(char *)MSelDir},
        {DI_TEXT,WidthUnderSide+2,15,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
   
        {DI_BUTTON,0,BottomSearchInFileDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,1,(char *)MSearch},
        {DI_BUTTON,0,BottomSearchInFileDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,0,(char *)MTables},
        {DI_BUTTON,0,BottomSearchInFileDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,0,(char *)MCancel}
     };                                            

     //믮  ᪠
     struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
     InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]), esr->UpSetRegExp, SearchInFileTypeDialog );
   
     DialogItems[NFI_CaseSensitive+OffsetDn].Selected = esr->CaseSensitive;
     DialogItems[NFI_WordSearch   +OffsetDn].Selected = esr->WordSearch;
     DialogItems[NFI_LinkSystem   ].Selected = esr->LinkSystem;
     DialogItems[NFI_SetRegExp    -OffsetUp].Selected = esr->SetRegExp;

     if( esr->SearchFromDir == SIFKind_FromCurDir )
        DialogItems[NFI_FromCurDir].Selected = true;
     else if( esr->SearchFromDir == SIFKind_OnlyCurDir )
        DialogItems[NFI_OnlyCurDir].Selected = true;
     else if( esr->SearchFromDir == SIFKind_SelDir )
        DialogItems[NFI_SelDir].Selected = true;
     else
        DialogItems[NFI_FromCurDir].Selected = true;


     esr->ExitCode=ExtSearchInfo.Dialog(ExtSearchInfo.ModuleNumber,-1,-1, SizeX,BottomSearchInFileDialog,Help_ExtSearch,DialogItems,
                              sizeof(DialogItems)/sizeof(DialogItems[0]));
    
     esr->CaseSensitive = DialogItems[NFI_CaseSensitive+OffsetDn].Selected;
     esr->WordSearch    = DialogItems[NFI_WordSearch   +OffsetDn].Selected;
     esr->LinkSystem    = DialogItems[NFI_LinkSystem   ].Selected;
     esr->SetRegExp     = DialogItems[NFI_SetRegExp    -OffsetUp].Selected;   

     if( DialogItems[NFI_FromCurDir].Selected == true ) esr->SearchFromDir = SIFKind_FromCurDir;
     if( DialogItems[NFI_OnlyCurDir].Selected == true ) esr->SearchFromDir = SIFKind_OnlyCurDir;
     if( DialogItems[NFI_SelDir].Selected == true )     esr->SearchFromDir = SIFKind_SelDir;
   
     if ( esr->ExitCode == NFI_ButtonSearch ){ // "" 

        strncpy( esr->SearchStr, DialogItems[NFI_EditSearch].Data, LenSearchStr );
        SetRegKey(HKEY_CURRENT_USER,"","SearchStr"    ,esr->SearchStr    );
       
        strncpy( esr->MaskStr, DialogItems[NFI_MaskStr].Data, LenSearchStr );
        SetRegKey(HKEY_CURRENT_USER,"","MaskStr"    ,esr->MaskStr    );

        PreProcessMenu_Files( esr, 0 );
        ProcessMenu_Files( esr, 0 );

     }
     else if( esr->ExitCode == NFI_ButtonTables ){//⠭ ⠡  ன ᪠
        esr->CodeTableSearchInFile = ChoiceFromCodeTablesMenu( esr );
        if( esr->CodeTableSearchInFile >= -1 ) 
           SetRegKey(HKEY_CURRENT_USER,"","CodeTableSearchInFile",esr->CodeTableSearchInFile);
        continue;
     }
     break; //室  横
  }
}

// ᫥ ᪠  ப ᮤঠ饩 ७ \n
static int GetLenLastStr( char *MultiStr ){   
   char *Pos, *BegStr = MultiStr;
   for(;;){

      if( (Pos = strchr( MultiStr, '\n' )) != NULL ) 
         MultiStr = Pos+1;                         
      else  break;
   }

   return  (strlen(BegStr) - (MultiStr - BegStr));
}

// ப   \r  \n
static int ExtLenStr( char *Str ){   
   char *Pos;

   if( (Pos = strchr( Str, '\r' )) != NULL || (Pos = strchr( Str, '\n' )) != NULL  ){
      *Pos = '\0';
      return strlen( Str );
   }
   else return strlen( Str ); 
}

//ᮤন  ப ਧ  ப  ᪥  ॣᯠ
static RX_ConsistStrEOL( char *Str ){
   if( strstr( Str, "\n" ) != NULL ) 
      return 1;
   else
      return 0;
}
//***************************************************************************
//  
//***************************************************************************
void ReplaceText( ExtSearchReg *esr, char *_ConvertReplace ){

   int LenStrReplace = strlen( _ConvertReplace );
   int EndAdd = 0;//ਧ    ப( 塞, 稭  \r  \n)

   char *TmpReplaceStr = (char*)HeapAlloc( esr->Heap, 0, esr->LenCurStr + LenStrReplace + 1);
   char *TmpReplaceStrPtr = TmpReplaceStr;

   char *TmpAddStr     = (char*)HeapAlloc( esr->Heap, 0, esr->LenCurStr + LenStrReplace + 1 );


   *TmpReplaceStr = '\0';
   *TmpAddStr     = '\0';

   EditorGetString edgs;

   edgs.StringNumber = -1;
   ExtSearchInfo.EditorControl( ECTL_GETSTRING, (void*)&edgs );

   strncpy( TmpReplaceStr, edgs.StringText, esr->ei.CurPos );
   *(TmpReplaceStr + esr->ei.CurPos) = '\0';
   strcat( TmpReplaceStr, _ConvertReplace );

   //AV 22.12.99 ⥯ ᬥ饭  १  esr->FindStr
   int OffsetToLastPartStr = esr->ei.CurPos + strlen( esr->FindStr ) ; //esr->LenStrSearchTmp

   //AV 01.12.99 모 \n  \r  ᪠  ॣᬯ
   //if( esr->SetRegExp ) OffsetToLastPartStr -= GetNumDelStr( SearchStr );

   //AV 08.12.99 ᫨ ᬥ饭 ॢᨫ  ப
   if( OffsetToLastPartStr > edgs.StringLength ){
      EndAdd = 1;
      OffsetToLastPartStr = edgs.StringLength;           
   }
      
   strcat( TmpReplaceStr, (edgs.StringText + OffsetToLastPartStr) );
    
   EditorSetString edss;
   edss.StringEOL    = NULL;

   //AV 11.11.99  ᨬ \n  ᪥  ॣᯠ - ᫨ﭨ ப
   if( esr->SetRegExp ){
      //char LastSymb[3];

      //strncpy( LastSymb, SearchStr + strlen(esr->SearchStr) - 2, 2);
      if( RX_ConsistStrEOL( esr->FindStr ) || EndAdd ){

         edgs.StringNumber = esr->ei.CurLine+1;
   
         if( esr->ei.CurLine < (esr->ei.TotalLines-1) && ExtSearchInfo.EditorControl( ECTL_GETSTRING, (void*)&edgs ) == true ){
            TmpAddStr      = (char*)HeapReAlloc( esr->Heap, 0, TmpAddStr,     edgs.StringLength + 1 );
            TmpReplaceStr  = (char*)HeapReAlloc( esr->Heap, 0, TmpReplaceStr,    esr->LenCurStr + LenStrReplace + 1 + edgs.StringLength + 10 );
            TmpReplaceStrPtr = TmpReplaceStr;

            strncpy( TmpAddStr, edgs.StringText, edgs.StringLength + 1 );

            if( ExtSearchInfo.EditorControl( ECTL_DELETESTRING, NULL ) == true ){
               edgs.StringNumber =  -1;
               ExtSearchInfo.EditorControl( ECTL_GETSTRING, (void*)&edgs );
               strcat( TmpReplaceStr, TmpAddStr );                            
            }
          }
      }

      //᫨  ப- ᨬ ७, ࠧ ப   ᪮쪮  ⠢塞 
      char *PosNewStr;
      int Del = 0;
      while( *TmpReplaceStr && ( (PosNewStr = strchr(TmpReplaceStr, '\r' )) != NULL || (PosNewStr = strchr(TmpReplaceStr, '\n' )) != NULL ) ){

         //塞 ப  ࠧ  ப
         Del = 1;
         edss.StringNumber = esr->ei.CurLine++;
         edss.StringLength = ExtLenStr(TmpReplaceStr);
         *(TmpReplaceStr + edss.StringLength) = '\0';
         *PosNewStr = '\0';
         edss.StringText   = TmpReplaceStr;    
         ExtSearchInfo.EditorControl( ECTL_SETSTRING, (void*)&edss );

         TmpReplaceStr = ++PosNewStr; 
         if( *PosNewStr == '\n' ) TmpReplaceStr++;

         edgs.StringNumber =  edss.StringNumber;
         ExtSearchInfo.EditorControl( ECTL_GETSTRING, (void*)&edgs );

         //⠢  ⮩ ப         
         SetEditorPosition( esr, edss.StringNumber, edgs.StringLength, 0, 1, esr->ReverseSearch );
         ExtSearchInfo.EditorControl( ECTL_INSERTSTRING, NULL );

      }

      if( Del ){
         // ᫥ ⠢ ᪠ 
         LenStrReplace =  GetLenLastStr( _ConvertReplace );
         esr->ei.CurPos = 0;
         SetEditorPosition( esr, esr->ei.CurLine, esr->ei.CurPos, 0, 1, esr->ReverseSearch );
      } 
   }
   edss.StringText   = TmpReplaceStr;    
   edss.StringLength = strlen(TmpReplaceStr);
   edss.StringNumber = esr->ei.CurLine; 
   edss.StringEOL    = "";

   ExtSearchInfo.EditorControl( ECTL_SETSTRING, (void*)&edss );

   //AV 16.11.99   
   esr->LenStrReplace = LenStrReplace;

   if( TmpReplaceStrPtr ) HeapFree( esr->Heap, 0, TmpReplaceStrPtr );
   if( TmpAddStr        ) HeapFree( esr->Heap, 0, TmpAddStr        );
}

//***************************************************************************
//  롮 ਠ 
//***************************************************************************
static int MakeChoiceForReplace( char *TmpSearchStr, char *TmpReplaceStr, ExtSearchReg *esr ){

      int SizeX;

      if( !esr->SearchInFile ){
         //। ਭ   ᨬ  ࠧ  ।
         if( esr->ei.WindowSizeX > 80 ) SizeX = esr->ei.WindowSizeX - BeforeLeft; 
         else SizeX = DefSizeX;
      }
      else SizeX = DefSizeX;
      //

     //樠  
     struct InitDialogItem InitItems[]={
        {DI_DOUBLEBOX,WidthUnderSide,1,SizeX-WidthUnderSide-1,BottomChoiceReplaceDialog-WidthUnder,0,0,0,0,(char *)MExtReplaceTitle},
        {DI_TEXT,WidthUnderSide+2,2,0,0,0,0,DIF_BOXCOLOR,0,(char *)MReplace2},
        {DI_EDIT,WidthUnderSide+2,3,SizeX-WidthUnderSide-3,0,0,0,DIF_BOXCOLOR,0,TmpSearchStr },
        {DI_TEXT,WidthUnderSide+2,4,0,0,0,0,DIF_BOXCOLOR,0,(char *)MWith},
        {DI_EDIT,WidthUnderSide+2,5,SizeX-WidthUnderSide-3,0,0,0,DIF_BOXCOLOR,0,TmpReplaceStr },   
        {DI_TEXT,WidthUnderSide+2,6,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},  

        {DI_BUTTON,0,BottomChoiceReplaceDialog-WidthUnder-1,0,0,true,0,DIF_CENTERGROUP,1,(char *)MReplace},
        {DI_BUTTON,0,BottomChoiceReplaceDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,0,(char *)MAll},
        {DI_BUTTON,0,BottomChoiceReplaceDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,0,(char *)MSkip},
        {DI_BUTTON,0,BottomChoiceReplaceDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,0,(char *)MCancel}
     };
   
     //믮  ᪠
     struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
     InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]) );
   
     return ExtSearchInfo.Dialog(ExtSearchInfo.ModuleNumber,-1,-1, SizeX,BottomChoiceReplaceDialog,Help_ExtSearch,DialogItems,
                              sizeof(DialogItems)/sizeof(DialogItems[0]));
}

//***************************************************************************
//  楤 롮 ०  
//***************************************************************************
static int ProcReplace( ExtSearchReg *esr ){

   esr->Replace = 1;
   esr->ContinueSearch = false; 

   esr->WasReplace = 1; //AV 30.03.00  ० த 

   while( ProcSearch( esr ) ){  
      int Choice = 0, Skip = 0;

      if( !esr->AllProc ){      
         /*char *TmpSearchStr = (char*)HeapAlloc( esr->Heap, 0, esr->ei.WindowSizeX+2);
         char *TmpReplaceStr = (char*)HeapAlloc( esr->Heap, 0, esr->ei.WindowSizeX+2);
         char TmpTemplate[] = "\"%s\"";
         char *TmpMess = (char*)HeapAlloc( esr->Heap, 0, esr->ei.WindowSizeX );
         int SizeX = esr->ei.WindowSizeX-20;
         //AV 29.03.00 뢮 ⮫쪮 ,    ࠭
         strncpy( TmpMess, esr->FindStr, SizeX );
         *(TmpMess+SizeX) = '\0';
         sprintf( TmpSearchStr,  TmpTemplate, TmpMess );//AV 22.12.99  SearchStr  esr->FindStr
         if( !esr->SetRegExp ){
            strncpy( TmpMess, esr->ConvertReplace, SizeX );
            *(TmpMess+SizeX) = '\0';
            sprintf( TmpReplaceStr, TmpTemplate, TmpMess );
         }
         else{
            strncpy( TmpMess, esr->RXConvertReplace, SizeX );
            *(TmpMess+SizeX) = '\0';
            sprintf( TmpReplaceStr, TmpTemplate, TmpMess );
         }*/
         char TmpSearchStr[LenSearchStr];
         strncpy( TmpSearchStr, esr->FindStr, LenSearchStr-1 );

         char TmpReplaceStr[LenSearchStr];

         if( !esr->SetRegExp )
            strncpy( TmpReplaceStr, esr->ConvertReplace, LenSearchStr-1 );
         else{
            strncpy( TmpReplaceStr, esr->RXConvertReplace, LenSearchStr-1 );
         }

         ConvertToOEM( esr, TmpReplaceStr, LenSearchStr );//AV 16.11.99

         //if( esr->SetSelect ) ResetStandardSelect( esr ); 

         /*char *MsgItems[]={GetMsg(MExtReplaceTitle), GetMsg(MReplace2), TmpSearchStr, GetMsg(MWith), TmpReplaceStr,
           GetMsg(MReplace), GetMsg(MAll), GetMsg(MSkip), GetMsg(MCancel) };
           Choice = ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,FMSG_DOWN,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),4);
         */

         Choice = MakeChoiceForReplace( TmpSearchStr, TmpReplaceStr, esr );

         /*HeapFree( esr->Heap, 0, TmpSearchStr );
         HeapFree( esr->Heap, 0, TmpReplaceStr );
         HeapFree( esr->Heap, 0, TmpMess );*/

         //⠭ ࠭ ⠭⭮ 뤥
         if( esr->SetSelect )
            SetStandardSelect( esr, 1 );
         //

      }
                    
      switch( Choice ){  
  
         case -1: //Cancel
           return -1;

         case NCRI_ButtonReplace:  //Replace
           break;
   
         case NCRI_ButtonAll:{  //All
           if( !esr->AllProc ){
              char *MsgItems[]={ GetMsg(MExtReplaceTitle), GetMsg(MProcReplace) };
              ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,0,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),0);
           }
           esr->AllProc = 1;                                                                        
         }
         break;
   
         case NCRI_ButtonSkip:  //Skip
           Skip = 1;
           esr->NumFindForReplace--;
           //AV 07.08.00 ..   뫮  ᫥騩  稭   ।饣  ᫮ 
           esr->LenStrReplace = esr->LenStrSearchTmp; 
           break;
   
         case NCRI_ButtonCancel:  //Cancel
           return -1;             
      }
      
      ExtSearchInfo.EditorControl( ECTL_GETINFO, &esr->ei );
      if( !Skip ){
         esr->SetSelect = true;
         if( !esr->SetRegExp ) ReplaceText( esr, esr->ConvertReplace );
         else                  ReplaceText( esr, esr->RXConvertReplace );

         ExtSearchInfo.EditorControl( ECTL_GETINFO, &esr->ei );                                                         
         esr->ei_save = esr->ei; //  ⠭ 樨 ᫥ 
      }

      esr->ContinueSearch = true; 
  }

  if( esr->NumFindForReplace ){
     struct EditorSetPosition esp;    

     esr->ei = esr->ei_save;

     //⠭  ᫥ , ..    㦥 堫
     esp.CurLine=esr->ei.CurLine;
     esp.CurPos=esr->ei.CurPos;
     esp.TopScreenLine=esr->ei.TopScreenLine;
     esp.LeftPos=esr->ei.LeftPos;
     esp.CurTabPos=-1;
     esp.Overtype=-1;
     ExtSearchInfo.EditorControl(ECTL_SETPOSITION,&esp); 

     if( esr->SetSelect && esr->LenStrReplace ){
        if( esr->FromSearch != 2 ){
           SetEditorPosition( esr, esr->ei.CurLine, esr->ei.CurPos, 1, 0, esr->ReverseSearch );
           Select( esr, esr->ei.CurLine, esr->ei.CurPos, esr->LenStrReplace );
        }else if( esr->FromSearch == 2 )  
           SetStandardSelect( esr, 1 );//⠭ ࠭ ⠭⭮ 뤥
     }

     if( esr->AllProc ){

        char StrMade[80];
   
        sprintf( StrMade, "%s %ld", GetMsg(MReplacesMade), esr->NumFindForReplace );
   
        char *MsgItems[]={ GetMsg(MExtReplaceTitle), StrMade, GetMsg(MOk) };

        ExtSearchInfo.EditorControl( ECTL_REDRAW, NULL );//㥬  ।
   
        ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,0,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
     }
  }


  return -1;
}
//***************************************************************************
//  䥩᭠  ᪠  
//***************************************************************************
static void RunSearchAndReplace( ExtSearchReg *esr )
{

  int SizeX, AddrHistory, AddrReplaceHistory;


  GetRegExtSearch( esr );

  //AV 16.12.99 ᬥ饭   
  int OffsetDn = 0, OffsetUp = 0;
  if( esr->UpSetRegExp ){
     OffsetDn = CHECKBOX_MOVE_DN;
     OffsetUp = CHECKBOX_MOVE_UP;
  }  

  PreProcessSearch( esr, &SizeX, &AddrHistory, &AddrReplaceHistory, NULL );       

  //樠   ᪠
  struct InitDialogItem InitItems[]={
     {DI_DOUBLEBOX,WidthUnderSide,1,SizeX-WidthUnderSide-1,BottomReplaceDialog-WidthUnder,0,0,0,0,(char *)MExtReplaceTitle},
     {DI_TEXT,WidthUnderSide+2,2,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrForSearch},
     {DI_EDIT,WidthUnderSide+2,3,SizeX-WidthUnderSide-3,0,true,AddrHistory,DIF_HISTORY,0, esr->SearchStr },
     {DI_TEXT,WidthUnderSide+2,4,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrForReplace},
     {DI_EDIT,WidthUnderSide+2,5,SizeX-WidthUnderSide-3,0,0,AddrReplaceHistory,DIF_HISTORY,0, esr->ReplaceStr },
     {DI_TEXT,WidthUnderSide,6,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
     {DI_CHECKBOX,WidthUnderSide+2,7,0,0,0,0,0,0,(char *)MCaseSensitive},
     {DI_CHECKBOX,WidthUnderSide+2,8,0,0,0,0,0,0,(char *)MWordSearch},
     {DI_CHECKBOX,WidthUnderSide+2,9,0,0,0,0,0,0,(char *)MReverseSearch},
     {DI_CHECKBOX,WidthUnderSide+2,10,0,0,0,0,0,0,(char *)MSetRegExp},
     {DI_CHECKBOX,WidthUnderSide+2+25,7,0,0,0,0,0,0,(char *)MPickUpWord},
     {DI_CHECKBOX,WidthUnderSide+2+25,8,0,0,0,0,0,0,(char *)MSelect},    
     {DI_CHECKBOX,WidthUnderSide+2+25,9,0,0,0,0,0,0,(char *)MLinkSystem},
     {DI_CHECKBOX,WidthUnderSide+2+25,10,0,0,0,0,0,0,(char *)MPutInClipBoard},
     {DI_TEXT,WidthUnderSide+2,11,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
     {DI_RADIOBUTTON, WidthUnderSide+2,12,0,0,0,0,DIF_GROUP,0,(char *)MFromCursor},         
     {DI_RADIOBUTTON, WidthUnderSide+2,13,0,0,0,0,0,0,(char *)MGlobal},         
     {DI_RADIOBUTTON, WidthUnderSide+2,14,0,0,0,0, 0,0,(char *)MSelText},
     {DI_TEXT,WidthUnderSide+2,15,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},

      {DI_BUTTON,0,BottomReplaceDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,1,(char *)MReplace},
      {DI_BUTTON,0,BottomReplaceDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,0,(char *)MCancel}
   };
 
   //믮  ᪠
   struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
   InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]), esr->UpSetRegExp, ReplaceTypeDialog );
 
   DialogItems[NRI_CaseSensitive+OffsetDn].Selected = esr->CaseSensitive;
   DialogItems[NRI_ReverseSearch+OffsetDn].Selected = esr->ReverseSearch;
   DialogItems[NRI_WordSearch   +OffsetDn].Selected = esr->WordSearch;
   DialogItems[NRI_PickUpWord   ].Selected = esr->PickUpWord;
   DialogItems[NRI_Select       ].Selected = esr->SetSelect;
   DialogItems[NRI_LinkSystem   ].Selected = esr->LinkSystem;
   DialogItems[NRI_SetRegExp    -OffsetUp].Selected = esr->SetRegExp;
   DialogItems[NRI_PutInClipBoard].Selected = esr->PutInClipBoard;
 
   DialogItems[NRI_FromCursor + esr->FromSearch].Selected = 1;
 
   int ExitCode;

   for(;;){
      ExitCode=ExtSearchInfo.Dialog(ExtSearchInfo.ModuleNumber,-1,-1, SizeX,BottomReplaceDialog,Help_ExtReplace,DialogItems,
                            sizeof(DialogItems)/sizeof(DialogItems[0]));
      if( esr->CheckEmptyReplace == true && DialogItems[NRI_EditReplace].Focus != true && DialogItems[NRI_ButtonReplace].Focus != true && ExitCode == NRI_ButtonReplace && !*DialogItems[NRI_EditReplace].Data ){
         DialogItems[NRI_EditSearch].Focus  = false;
         DialogItems[NRI_EditReplace].Focus = true;
         continue;
      }
      break;
   }
 
   esr->CaseSensitive = DialogItems[NRI_CaseSensitive+OffsetDn].Selected;
   esr->ReverseSearch = DialogItems[NRI_ReverseSearch+OffsetDn].Selected;
   esr->WordSearch    = DialogItems[NRI_WordSearch   +OffsetDn].Selected;
   esr->SetSelect     = DialogItems[NRI_Select       ].Selected;
   esr->PickUpWord    = DialogItems[NRI_PickUpWord   ].Selected;
   esr->LinkSystem    = DialogItems[NRI_LinkSystem   ].Selected;
   esr->SetRegExp     = DialogItems[NRI_SetRegExp    -OffsetUp].Selected;
   esr->PutInClipBoard= DialogItems[NRI_PutInClipBoard].Selected;
 
   if( DialogItems[NRI_FromCursor].Selected      ) esr->FromSearch = 0;
   else if( DialogItems[NRI_Global].Selected     ) esr->FromSearch = NRI_Global - NRI_FromCursor;
   else if( DialogItems[NRI_SelText].Selected    ) esr->FromSearch = NRI_SelText - NRI_FromCursor;
   else esr->FromSearch = 0;

   if ( ExitCode == NRI_ButtonReplace ){ // ""

      SetRegExtSearch( esr ); 
 
      strncpy( esr->SearchStr, DialogItems[NRI_EditSearch].Data, LenSearchStr );
      SetRegKey(HKEY_CURRENT_USER,"","SearchStr"    ,esr->SearchStr    );
      strncpy( esr->ReplaceStr, DialogItems[NRI_EditReplace].Data, LenSearchStr );
      SetRegKey(HKEY_CURRENT_USER,"","ReplaceStr"    ,esr->ReplaceStr    );
      esr->LenStrReplace = -1;
    
      //AV 02.11.99
      strcpy( esr->ConvertReplace, esr->ReplaceStr );
      ConvertFromOEM( esr, esr->ConvertReplace ); 
      //
 
      SetSearchStr_Buffers( esr );//AV 09.12.99
 
      //
      esr->AllProc = 0;
      esr->NumFindForReplace = 0;
      esr->NumCount = 0;
 
      ProcReplace( esr );
 
   }
}


//***************************************************************************
//  䥩᭠    䠩
//***************************************************************************
static void RunReplaceInFile( ExtSearchReg *esr )
{

  for( ;; ){
     int SizeX, AddrHistory, AddrMaskHistory, AddrReplaceHistory;
   
     GetRegExtSearch( esr ); 
   
     //AV 16.12.99 ᬥ饭   
     int OffsetDn = 0, OffsetUp = 0;
     if( esr->UpSetRegExp ){
        OffsetDn = CHECKBOX_MOVE_DN;
        OffsetUp = CHECKBOX_MOVE_UP - 1;
     }
   
    PreProcessSearch( esr, &SizeX, &AddrHistory, &AddrReplaceHistory, &AddrMaskHistory );       
   
    char TableName[53];
    memset( (void*)TableName, 0, 53 );
    *TableName = '[';
    GetTableName( esr, esr->CodeTableSearchInFile, TableName+1, 50 );
    *(TableName+strlen(TableName)) = ']';

     //樠   ᪠
     struct InitDialogItem InitItems[]={
        {DI_DOUBLEBOX,WidthUnderSide,1,SizeX-WidthUnderSide-1,4,0,0,0,0,""},
        {DI_DOUBLEBOX,WidthUnderSide,1,SizeX-WidthUnderSide-1,13,0,0,0,0,""},
        {DI_DOUBLEBOX,WidthUnderSide,1,SizeX-WidthUnderSide-1,BottomReplaceInFileDialog-WidthUnder,0,0,0,0,(char *)MExtReplaceTitle},
        {DI_TEXT,WidthUnderSide,4,0,0,0,0,DIF_BOXCOLOR,0,""},                 
        {DI_TEXT,SizeX-WidthUnderSide-1,4,0,0,0,0,DIF_BOXCOLOR,0,""},
        {DI_TEXT,WidthUnderSide+2,2,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrForMask},
        {DI_EDIT,WidthUnderSide+2,3,SizeX-WidthUnderSide-3,0,true,AddrMaskHistory,DIF_HISTORY,0, esr->MaskStr },
        {DI_TEXT,WidthUnderSide+2,5,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrForSearch},
        {DI_TEXT,WidthUnderSide+2+12,5,0,0,0,0,DIF_BOXCOLOR,0,(char *)TableName},
        {DI_EDIT,WidthUnderSide+2,6,SizeX-WidthUnderSide-3,0,0,AddrHistory,DIF_HISTORY,0, esr->SearchStr },
        {DI_TEXT,WidthUnderSide+2,7,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrForReplace},
        {DI_EDIT,WidthUnderSide+2,8,SizeX-WidthUnderSide-3,0,0,AddrReplaceHistory,DIF_HISTORY,0, esr->ReplaceStr },
        {DI_TEXT,WidthUnderSide+2,9,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
        {DI_CHECKBOX,WidthUnderSide+2,10,0,0,0,0,0,0,(char *)MCaseSensitive},
        {DI_CHECKBOX,WidthUnderSide+2,11,0,0,0,0,0,0,(char *)MWordSearch},
        {DI_CHECKBOX,WidthUnderSide+2,12,0,0,0,0,0,0,(char *)MSetRegExp},
        {DI_CHECKBOX,WidthUnderSide+2+25,10,0,0,0,0,0,0,(char *)MLinkSystem},
   
        {DI_TEXT,WidthUnderSide,13,0,0,0,0,DIF_BOXCOLOR,0,""},                 
        {DI_TEXT,SizeX-WidthUnderSide-1,13,0,0,0,0,DIF_BOXCOLOR,0,""},
        {DI_RADIOBUTTON, WidthUnderSide+2,14,0,0,0,0,DIF_GROUP,0,(char *)MFromCurDir},         
        {DI_RADIOBUTTON, WidthUnderSide+2,15,0,0,0,0,0,0,(char *)MOnlyCurDir},         
        {DI_RADIOBUTTON, WidthUnderSide+2,16,0,0,0,0,0,0,(char *)MSelDir},
        {DI_TEXT,WidthUnderSide+2,17,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
   
        {DI_BUTTON,0,BottomReplaceInFileDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,1,(char *)MReplace},
        {DI_BUTTON,0,BottomReplaceInFileDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,0,(char *)MTables},
        {DI_BUTTON,0,BottomReplaceInFileDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,0,(char *)MCancel}
     };                                            

     //믮  ᪠
     struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
     InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]), esr->UpSetRegExp, ReplaceInFileTypeDialog );
   
     DialogItems[NRFI_CaseSensitive+OffsetDn].Selected = esr->CaseSensitive;
     DialogItems[NRFI_WordSearch   +OffsetDn].Selected = esr->WordSearch;
     DialogItems[NRFI_LinkSystem   ].Selected = esr->LinkSystem;
     DialogItems[NRFI_SetRegExp    -OffsetUp].Selected = esr->SetRegExp;

     if( esr->SearchFromDir == SIFKind_FromCurDir )
        DialogItems[NRFI_FromCurDir].Selected = true;
     else if( esr->SearchFromDir == SIFKind_OnlyCurDir )
        DialogItems[NRFI_OnlyCurDir].Selected = true;
     else if( esr->SearchFromDir == SIFKind_SelDir )
        DialogItems[NRFI_SelDir].Selected = true;
     else
        DialogItems[NRFI_FromCurDir].Selected = true;

     esr->ExitCode=ExtSearchInfo.Dialog(ExtSearchInfo.ModuleNumber,-1,-1, SizeX,BottomReplaceInFileDialog,Help_ExtSearch,DialogItems,
                              sizeof(DialogItems)/sizeof(DialogItems[0]));
    
     esr->CaseSensitive = DialogItems[NRFI_CaseSensitive+OffsetDn].Selected;
     esr->WordSearch    = DialogItems[NRFI_WordSearch   +OffsetDn].Selected;
     esr->LinkSystem    = DialogItems[NRFI_LinkSystem   ].Selected;
     esr->SetRegExp     = DialogItems[NRFI_SetRegExp    -OffsetUp].Selected;   

     if( DialogItems[NRFI_FromCurDir].Selected == true ) esr->SearchFromDir = SIFKind_FromCurDir;
     if( DialogItems[NRFI_OnlyCurDir].Selected == true ) esr->SearchFromDir = SIFKind_OnlyCurDir;
     if( DialogItems[NRFI_SelDir].Selected == true )     esr->SearchFromDir = SIFKind_SelDir;
   
     if ( esr->ExitCode == NRFI_ButtonReplace ){ // "" 

        strncpy( esr->SearchStr, DialogItems[NRFI_EditSearch].Data, LenSearchStr );
        SetRegKey(HKEY_CURRENT_USER,"","SearchStr"    ,esr->SearchStr    );

        strncpy( esr->ReplaceStr, DialogItems[NRFI_EditReplace].Data, LenSearchStr );
        SetRegKey(HKEY_CURRENT_USER,"","ReplaceStr"    ,esr->ReplaceStr    );
       
        strncpy( esr->MaskStr, DialogItems[NRFI_MaskStr].Data, LenSearchStr );
        SetRegKey(HKEY_CURRENT_USER,"","MaskStr"    ,esr->MaskStr    );

        esr->LenStrReplace = -1;
      
        //AV 02.11.99
        strcpy( esr->ConvertReplace, esr->ReplaceStr );
        ConvertFromOEM( esr, esr->ConvertReplace ); 
        //
        PreProcessMenu_Files( esr, 1 );
        ProcessMenu_Files( esr, 1 );

     }
     else if( esr->ExitCode == NRFI_ButtonTables ){//⠭ ⠡  ன ᪠
        esr->CodeTableSearchInFile = ChoiceFromCodeTablesMenu( esr );
        if( esr->CodeTableSearchInFile >= -1 ) 
           SetRegKey(HKEY_CURRENT_USER,"","CodeTableSearchInFile",esr->CodeTableSearchInFile);
        continue;
     }
     break; //室  横
  }
}


             
static void ContinueSearch( ExtSearchReg *esr )
{
  ExtSearchInfo.EditorControl( ECTL_GETINFO, &esr->ei );
                   
   GetRegExtSearch( esr ); 
                          
   esr->NumFindForReplace = 0;
   esr->NumCount = 0; 

   esr->Replace = 0;
   esr->ContinueSearch = 1;

   //AV 31.01.00
   esr->ContinuePressDownKey  = 1;

   SetSearchStr_Buffers( esr );//AV 09.12.99
 
   if( !esr->WasReplace || esr->NoContinueReplace )
      ProcSearch( esr );  
   else
      ProcReplace( esr );
}

static void ReverseSearch( ExtSearchReg *esr )
{
  ExtSearchInfo.EditorControl( ECTL_GETINFO, &esr->ei );
                                                               
  GetRegExtSearch( esr ); 
 
  //AV 02.11.99 ᫨ ⥪ ⠭ "᪠ ।",  饬   
  esr->ReverseSearch = (esr->ReverseSearch == false) ? true : false;
 
  esr->NumFindForReplace = 0;
  esr->NumCount = 0;
 
  esr->Replace = 0;
  esr->ContinueSearch = 1; 

  //AV 31.01.00
  esr->ContinuePressDownKey  = 1;
 
  SetSearchStr_Buffers( esr );//AV 09.12.99
 
  if( !esr->WasReplace || esr->NoContinueReplace )
     ProcSearch( esr ); 
  else 
     ProcReplace( esr );  

}

//AV 01.12.99*********************************************************
//    ⮬ 
//AV 06.12.99 ࠫ ४
//********************************************************************
void CountSearch( ExtSearchReg *esr ){

   esr->Count = 1;

   int (*Proc)( ExtSearchReg *esr ) = !esr->SearchInFile ? ProcSearch : ProcFileSearch;
   HANDLE hScreen = NULL;

   while( Proc( esr ) ){

      if( !esr->AllProc ){//AV 10.12.99 
         esr->AllProc = 1;

         if( esr->SearchInFile )
            hScreen = ExtSearchInfo.SaveScreen( 0, 0, -1, -1 );

         char *MsgItems[]={ GetMsg(MExtSearchTitle), GetMsg(MProcCount) };
         ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,0,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),0);
      }

      esr->NumCount++;

      if( !esr->SearchInFile )
         ExtSearchInfo.EditorControl( ECTL_GETINFO, &esr->ei );

      esr->ContinueSearch = true; 
   }

   if( esr->SearchInFile && hScreen ) ExtSearchInfo.RestoreScreen( hScreen );

   if( esr->NumCount ){

      if( !esr->SearchInFile ){
         char StrMade[80];
    
         sprintf( StrMade, "%s %ld", GetMsg(MCountMade), esr->NumCount );
      
         char *MsgItems[]={ GetMsg(MExtSearchTitle), StrMade, GetMsg(MOk) };
      
         if( !esr->SearchInFile )
            ExtSearchInfo.EditorControl( ECTL_REDRAW, NULL );//㥬  ।
      
         ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,0,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
      }
   }

   esr->Count = 0;
}

//********************************************************************
//    䠩 ஥  㭪樨
//********************************************************************
static bool GetFun( ExtSearchReg *esr, char *FunName ){
   bool ret = false;
   char *BegStr, *BegPath, *BegNum, *EndNum;
   char Tmp[LenCurWord];

   BegStr = esr->StringBuff;
   while( (BegStr = strstr( BegStr, FunName )) != NULL ){
      GetCurWord( esr, Tmp, esr->StringBuff, esr->LenCurStr, BegStr-esr->StringBuff, NULL );
      if( strcmp(Tmp, FunName) ){
         BegStr++;
         continue;
      }
      break;
   }

   if( BegStr != NULL ){
      BegPath = strchr( BegStr, '?' );
      if( BegPath != NULL ){   
         BegNum = strchr( BegPath+1, '?' );
         if( BegNum != NULL ){
            //砥 + 䠩
            strncpy( esr->FilePath, BegPath+1, BegNum-BegPath-1 );
            *(esr->FilePath+(BegNum-BegPath-1)) = '\0';
            //砥  ப  ன 㭪
            EndNum = strchr( BegNum+1, '\n' );
            strncpy( Tmp, BegNum+1, EndNum-BegNum-1 );
            *(Tmp+(EndNum-BegNum-1)) = '\0';
            esr->NumStr = atoi( Tmp );   

            return true;
         }
      }
         
   }

   return ret;
}

//********************************************************************
//  室  㭪樨,  ன ⮨
//********************************************************************
static void GoToFun( ExtSearchReg *_esr, ExtSearchReg **esr ){

   (*esr)->str.StringNumber = -1; // ⥪ ப
   ExtSearchInfo.EditorControl( ECTL_GETSTRING, &(*esr)->str );
   ExtSearchInfo.EditorControl(ECTL_GETINFO,&(*esr)->ei);

   if( (*esr)->str.StringText ){
      char FunName[LenCurWord] = "";
      GetCurWord( (*esr), FunName, (*esr)->str.StringText, (*esr)->str.StringLength, (*esr)->ei.CurPos, NULL );

      char *PosEndPath;
      char PathFileName[1024] = "";
      char CurPath[1024]; 

      if( (PosEndPath = strrchr((*esr)->ei.FileName,'\\')) != NULL ){

        int Num = PosEndPath - (*esr)->ei.FileName;
        lstrcpyn( CurPath, (*esr)->ei.FileName, Num+1 );
        *(CurPath + Num + 1) = '\0';
        strcpy( PathFileName, CurPath );
        lstrcat( PathFileName, "\\" );
        lstrcat( PathFileName, "fcsbprj$.Far" );
      }else{
        lstrcpy( PathFileName, "fcsbprj$.Far" );
      }

      bool find = false;

      /*砫 ஡㥬   ᯨ᪥ 㭪権  ⥪饬 ⠫*/
      strcpy( (*esr)->FilePath, PathFileName );
      if( File2StringBuff( (*esr) ) == true ){

         find = GetFun( (*esr), FunName );
         if( (*esr)->StringBuff ){
            HeapFree( (*esr)->Heap, 0, (*esr)->StringBuff );
            (*esr)->StringBuff = NULL;
         }

         if( find == true )
            strcpy( PathFileName, (*esr)->FilePath );
      }

      /*⥯ ஡㥬   ᯨ᪥ 㭪権  ୥ ஥*/
      if( find == false ){
         strcpy( (*esr)->FilePath, (*esr)->PathRootPrj );
         strcat( (*esr)->FilePath, "\\fcsbprj$.Far" );
         if( File2StringBuff( (*esr) ) == true )
            find = GetFun( (*esr), FunName );
         if( find == true ){
            strcpy( PathFileName, (*esr)->PathRootPrj );
            strcat( PathFileName, "\\" );
            strcat( PathFileName, (*esr)->FilePath );
         }
      }

      if( find == true && *PathFileName != '\0' && (*esr)->NumStr > 0 ){

         if( stricmp( PathFileName, (*esr)->ei.FileName) ){
            unsigned long NumStr = (*esr)->NumStr;
            if( (*esr) ){
                HeapFree( _esr->Heap, 0, (*esr) );
                (*esr) = NULL;
            }

            ExtSearchInfo.Editor(
              PathFileName,
              NULL,                                
              0,
              0,
              -1,
              -1,
              EF_NONMODAL,                                     
              NumStr,
              1
            );
         }
         else
            SetEditorPosition( (*esr), (*esr)->NumStr, 0, 0, 0, 0 );            
      }
      else{
         char *MsgItems[]={GetMsg(MExtGoToFun),GetMsg(MNoFindFun),GetMsg(MOk)};
         ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
      }
   }

}


//********************************************************************
//  室  訡, ᠭ  ⥪饩 ப 
//********************************************************************
static void GoToError( ExtSearchReg *_esr ){

   bool  GoErr = false;   
   struct EditorGetString egs;
   egs.StringNumber = -1; // ⥪ ப
   ExtSearchInfo.EditorControl( ECTL_GETSTRING, &egs );

   if( egs.StringText ){

      int  NumTemplFileName   = GetRegKey(HKEY_CURRENT_USER,"","NumTemplFileName" , DefNumTemplFileName );
      int  NumTemplNumStr     = GetRegKey(HKEY_CURRENT_USER,"","NumTemplNumStr" , DefNumTemplNumStr );

      char TemplateGoToError[LenSearchStr];
      GetRegKey(HKEY_CURRENT_USER,"","TemplateGoToError", TemplateGoToError, DefTemplate, LenSearchStr );

      char *str = egs.StringText;
      SMatches match;
      PRegExp retest = new CRegExp;      
      retest->SetExpr( TemplateGoToError );
         
      if( retest->Parse( str, str, str + strlen(str), &match, NULL, -1 ) && match.s[0] >= 0 && match.e[0] >= 0 )
      {
         int stat = 0;
         if( (match.s[NumTemplFileName] < 0 || match.e[NumTemplFileName] < 0) ||
             (match.s[NumTemplNumStr] < 0 || match.e[NumTemplNumStr] < 0 )  
           ) stat = 1;

         if( !stat )
         {
            char Number[18] = "";
            strncpy( Number, str+match.s[NumTemplNumStr], match.e[NumTemplNumStr]-match.s[NumTemplNumStr] );

            GoErr = true; //諨  訡  

            char *MsgItems[]={ GetMsg(MExtGoToError), GetMsg(MExtProcGoToError) };
            ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,0,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),0);

            char FileName[1024] = "";
            char PathFileName[1024] = "";
            char CurPath[1024]; 
            strncpy( FileName, str+match.s[NumTemplFileName], match.e[NumTemplFileName]-match.s[NumTemplFileName] );

            //᫨ ⥩  ,   直 砩 稬   䠩  訡
            //  饬   ॡ㥬 䠩
            if( !strrchr(FileName,':') ){ /*᫨   */
               struct EditorInfo ei;
               ExtSearchInfo.EditorControl(ECTL_GETINFO,&ei);
               char *PosEndPath;

               if( (PosEndPath = strrchr(ei.FileName,'\\')) != NULL ){

                 int Num = PosEndPath - ei.FileName;
                 lstrcpyn( CurPath, ei.FileName, Num+1 );
                 *(CurPath + Num + 1) = '\0';
                 strcpy( PathFileName, CurPath );
                 lstrcat( PathFileName, "\\" );
               }
            }

            lstrcat( PathFileName, FileName );

            HANDLE f;
            WIN32_FIND_DATA fd;
            if( (f = FindFirstFile( PathFileName, &fd )) == INVALID_HANDLE_VALUE )
            {
                ExtSearchReg *esr_f = (ExtSearchReg *)malloc( sizeof(ExtSearchReg) );
                if( esr_f ){
                   memset( esr_f, '\0', sizeof(ExtSearchReg) );
                   esr_f->OnlySearchFile = 1;
                   strcpy( esr_f->OnlySearchFileName, FileName );     
                   ProcFiles( esr_f, CurPath, 0 ); // 䠩 稭  ⥪饣 ⠫    ⠫

                   if( esr_f->OnlySearchFileTrue )
                     strcpy( PathFileName, esr_f->OnlySearchFileName );
                   free( esr_f );
                }
            }
            else FindClose( f );

            delete retest;
            retest = NULL;

            int NumStr = atoi( Number );

            if( *FileName != '\0' && NumStr > 0 ){

               ExtSearchInfo.Editor(
                 PathFileName,
                 NULL,                                
                 0,
                 0,
                 -1,
                 -1,
                 EF_NONMODAL,                                     
                 NumStr,
                 1
               );
            }
         }
      } 

      if( retest ) delete retest;
   }

   if( GoErr == false ){
      ExtSearchReg *esr = (ExtSearchReg *)HeapAlloc( _esr->Heap, 0, sizeof(ExtSearchReg) );
      *esr = *_esr;
      char *MsgItems[]={ GetMsg(MExtGoToFun), GetMsg(MExtProcGoToFun) };
      ExtSearchInfo.Message(ExtSearchInfo.ModuleNumber,0,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),0);
      GoToFun( _esr, &esr );
      if( esr ) HeapFree( _esr->Heap, 0, esr );
   }
}

#pragma argsused
//********************************************************************
//  㤠  ப
//********************************************************************
static void DeleteEqString( ExtSearchReg *esr ){

   struct EditorGetString egs;
   struct EditorSetPosition esp;

   int isEndOfFile = 0;
   int CurStr  = 0;
   unsigned long LenStr = 32000, LenCurStr;

   char *Str = (char*)farmalloc( LenStr );

   memset( &egs, '\0', sizeof(struct EditorGetString) );
   memset( &esp, '\0', sizeof(struct EditorSetPosition) );

   egs.StringNumber = CurStr;

   while( ExtSearchInfo.EditorControl( ECTL_GETSTRING, &egs ) == TRUE ){

      LenCurStr = egs.StringLength;
      if( LenCurStr > LenStr ){
         Str = (char*)farrealloc( Str, LenCurStr );
         if( Str ) LenStr = LenCurStr;
         else break;
      }

      strcpy( Str, egs.StringText );

      for(;;){
         egs.StringNumber = CurStr + 1;
         if( ExtSearchInfo.EditorControl( ECTL_GETSTRING, &egs ) == TRUE ){
            if( LenCurStr != egs.StringLength ){
               CurStr++;
               break;
            }else{
               if( !memcmp( egs.StringText, Str, LenCurStr ) ){
                  esp.CurLine = egs.StringNumber;
                  if( ExtSearchInfo.EditorControl( ECTL_SETPOSITION, &esp ) == true && ExtSearchInfo.EditorControl( ECTL_DELETESTRING, NULL ) == true )
                     continue;
                  else{
                     isEndOfFile = 1;
                     break;
                  }
               }else{
                  CurStr++;
                  break;
               }   
            }
         }
         else{ 
            isEndOfFile = 1;
            break;
         }
      }

      if( isEndOfFile ) break;
      else
         egs.StringNumber = CurStr;

   }
   farfree( Str );
}


//********************************************************************
//  楤 䨣樨 
//********************************************************************
static void ExtSearchConfiguration( void ){

  int  AddrWord1History       = (int)ExtWord1HistoryName;
  int  AddrWord2History       = (int)ExtWord2HistoryName;
  int  AddrGoToErrorHistory   = (int)ExtTemplateHistoryName;
  int  AddrPathRootPrjHistory = (int)ExtPathRootPrjHistoryName;

  int  AutoSearchInSelect = GetRegKey(HKEY_CURRENT_USER,"","AutoSearchInSelect" , false );
  int  DN_Position        = GetRegKey(HKEY_CURRENT_USER,"","DN_Position" , false );
  int  UpSetRegExp        = GetRegKey(HKEY_CURRENT_USER,"","UpSetRegExp" , false );
  int  BkGrSelect         = GetRegKey(HKEY_CURRENT_USER,"","BkGrSelect" , DefBkGrSelect );
  int  ClrSelect          = GetRegKey(HKEY_CURRENT_USER,"","ClrSelect" , DefClrSelect );
  int  KindSelect         = GetRegKey(HKEY_CURRENT_USER,"","KindSelect" , 0 );
  int  CheckESC           = GetRegKey(HKEY_CURRENT_USER,"","CheckESC" , false );
  int  NoSaveGlobal       = GetRegKey(HKEY_CURRENT_USER,"","NoSaveGlobal", false );
  int  NoContinueReplace  = GetRegKey(HKEY_CURRENT_USER,"","NoContinueReplace", false );  
  int  CheckEmptyReplace  = GetRegKey(HKEY_CURRENT_USER,"","CheckEmptyReplace", false );  
  int  NumTemplFileName   = GetRegKey(HKEY_CURRENT_USER,"","NumTemplFileName" , DefNumTemplFileName );
  int  NumTemplNumStr     = GetRegKey(HKEY_CURRENT_USER,"","NumTemplNumStr" , DefNumTemplNumStr );

  char StrBkGrSelect[LenSearchStr], StrClrSelect[LenSearchStr];
  char StrNumTemplFileName[LenSearchStr], StrNumTemplNumStr[LenSearchStr];

  itoa( BkGrSelect, StrBkGrSelect, 10  );
  itoa( ClrSelect, StrClrSelect, 10  );

  itoa( NumTemplFileName, StrNumTemplFileName, 10  );
  itoa( NumTemplNumStr, StrNumTemplNumStr, 10  );

  //砥 ப ᨬ 室  ᫮ 
  GetWordStr( esr->SymbWord1Str, esr->SymbWord2Str, esr->TemplateGoToError, esr->PathRootPrj );

  //AV 01.12.99 䮪   NCI_ButtonCansel

  //樠   㮭䨣樨 
  struct InitDialogItem InitItems[]={
     {DI_DOUBLEBOX,WidthUnderSide,1,DefCfgSizeX-WidthUnderSide-1,BottomCfgDialog-WidthUnder,0,0,0,0,(char *)MExtSearchTitle},
     {DI_CHECKBOX,WidthUnderSide+2,2,0,0,0,0,0,0,(char *)MAutoSearchInSelect},
     {DI_CHECKBOX,WidthUnderSide+2,3,0,0,0,0,0,0,(char *)MDN_Position},
     {DI_CHECKBOX,WidthUnderSide+2,4,0,0,0,0,0,0,(char *)MUpSetRegExp},
     {DI_CHECKBOX,WidthUnderSide+2,5,0,0,0,0,0,0,(char *)MCheckESC},
     {DI_CHECKBOX,WidthUnderSide+2,6,0,0,0,0,0,0,(char *)MNoSaveGlobal},
     {DI_CHECKBOX,WidthUnderSide+2,7,0,0,0,0,0,0,(char *)MNoContinueReplace},
     {DI_CHECKBOX,WidthUnderSide+2,8,0,0,0,0,0,0,(char *)MCheckEmptyReplace},
     {DI_TEXT,   WidthUnderSide,9,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
     {DI_TEXT,   WidthUnderSide+2,10,0,0,0,0,DIF_BOXCOLOR,0,(char *)MTextSel},
     {DI_RADIOBUTTON, WidthUnderSide+2,11,0,0,0,0,DIF_GROUP,0,(char *)MSelStandard},         
     {DI_RADIOBUTTON, WidthUnderSide+30,11,0,0,0,0,0,0,(char *)MSelColorAPI},         
     {DI_FIXEDIT,WidthUnderSide+2,12,WidthUnderSide+2+1,0,0,0,0,0,StrBkGrSelect},
     {DI_FIXEDIT,WidthUnderSide+5,12,WidthUnderSide+5+1,0,0,0,0,0,StrClrSelect },
     {DI_TEXT,   WidthUnderSide+6+2,12,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrAttrSelect},
     {DI_TEXT,   WidthUnderSide,13,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
     {DI_TEXT,WidthUnderSide+2,14,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrWord1},
     {DI_EDIT,WidthUnderSide+2,15,DefCfgSizeX-WidthUnderSide-3,0,0,AddrWord1History,DIF_HISTORY|DIF_LEFTTEXT,0, esr->SymbWord1Str },
     {DI_TEXT,WidthUnderSide+2,16,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrWord2},
     {DI_EDIT,WidthUnderSide+2,17,DefCfgSizeX-WidthUnderSide-3,0,0,AddrWord2History,DIF_HISTORY|DIF_LEFTTEXT,0, esr->SymbWord2Str },
     {DI_TEXT,   WidthUnderSide,18,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
     {DI_TEXT,WidthUnderSide+2,19,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrTemplateGoToError},
     {DI_TEXT,WidthUnderSide+30,19,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrNumTemplFileName},
     {DI_FIXEDIT,WidthUnderSide+36,19,WidthUnderSide+36+2,0,0,0,0,0,StrNumTemplFileName},
     {DI_TEXT,WidthUnderSide+40,19,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrNumTemplNumStr},
     {DI_FIXEDIT,WidthUnderSide+47,19,WidthUnderSide+47+2,0,0,0,0,0,StrNumTemplNumStr },
     {DI_EDIT,WidthUnderSide+2,20,DefCfgSizeX-WidthUnderSide-3,0,0,AddrGoToErrorHistory,DIF_HISTORY|DIF_LEFTTEXT,0, esr->TemplateGoToError },
     {DI_TEXT,WidthUnderSide+2,21,0,0,0,0,DIF_BOXCOLOR,0,(char *)MStrPathRootPrjName},
     {DI_EDIT,WidthUnderSide+2,22,DefCfgSizeX-WidthUnderSide-3,0,0,AddrPathRootPrjHistory,DIF_HISTORY|DIF_LEFTTEXT,0, esr->PathRootPrj },
     {DI_TEXT,   WidthUnderSide,23,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
     {DI_BUTTON,0,BottomCfgDialog-WidthUnder-1,0,0,0,0,DIF_CENTERGROUP,1,(char *)MOk},
     {DI_BUTTON,0,BottomCfgDialog-WidthUnder-1,0,0,true,0,DIF_CENTERGROUP,0,(char *)MCancel}
  };

  //믮  ᪠
  struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
  InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]), -1, ConfigTypeDialog );

  DialogItems[NCI_AutoSearchInSelect].Selected = AutoSearchInSelect;
  DialogItems[NCI_DN_Position].Selected = DN_Position;
  DialogItems[NCI_UpSetRegExp].Selected = UpSetRegExp;
  DialogItems[NCI_CheckESC].Selected    = CheckESC;
  DialogItems[NCI_NoSaveGlobal].Selected  = NoSaveGlobal;
  DialogItems[NCI_NoContinueReplace].Selected  = NoContinueReplace;
  DialogItems[NCI_CheckEmptyReplace].Selected  = CheckEmptyReplace;
  if( !KindSelect )
     DialogItems[NCI_SelStandard].Selected = 1;
  else
     DialogItems[NCI_SelColorAPI].Selected = 1;

  int ExitCode=ExtSearchInfo.Dialog(ExtSearchInfo.ModuleNumber,-1,-1, DefCfgSizeX, BottomCfgDialog,Help_ExtConfig,DialogItems,
                           sizeof(DialogItems)/sizeof(DialogItems[0]));

  if ( ExitCode == NCI_ButtonOk ){ // "Ok"              

     strncpy( StrBkGrSelect, DialogItems[NCI_BkGrSelect].Data, LenSearchStr );
     strncpy( StrClrSelect,  DialogItems[NCI_ClrSelect].Data,  LenSearchStr );
     BkGrSelect = atoi( StrBkGrSelect );
     ClrSelect  = atoi( StrClrSelect  );                      

     strncpy( StrNumTemplFileName, DialogItems[NCI_NumTemplFileName].Data, LenSearchStr );
     strncpy( StrNumTemplNumStr,   DialogItems[NCI_NumTemplNumStr].Data,   LenSearchStr );
     NumTemplFileName = atoi( StrNumTemplFileName );
     NumTemplNumStr   = atoi( StrNumTemplNumStr   );

     if( NumTemplFileName >= 0 && NumTemplNumStr >= 0 ){
        SetRegKey( HKEY_CURRENT_USER,"","NumTemplFileName", NumTemplFileName );
        SetRegKey( HKEY_CURRENT_USER,"","NumTemplNumStr",   NumTemplNumStr  );
     }

     if( BkGrSelect >= 0 && BkGrSelect <= 15 && ClrSelect >= 0 && ClrSelect <= 15 ){
        SetRegKey( HKEY_CURRENT_USER,"","BkGrSelect", BkGrSelect );
        SetRegKey( HKEY_CURRENT_USER,"","ClrSelect",  ClrSelect  );
     }

     strncpy( esr->SymbWord1Str, DialogItems[NCI_SymbWord1Str].Data, LenSearchStr );
     strncpy( esr->SymbWord2Str, DialogItems[NCI_SymbWord2Str].Data, LenSearchStr );
     strncpy( esr->PathRootPrj, DialogItems[NCI_PathRootPrj].Data, LenSearchStr );
     strncpy( esr->TemplateGoToError, DialogItems[NCI_TemplateGoToError].Data, LenSearchStr );

     SetWordStr( esr->SymbWord1Str, esr->SymbWord2Str, esr->TemplateGoToError, esr->PathRootPrj );

     AutoSearchInSelect = DialogItems[NCI_AutoSearchInSelect].Selected;
     SetRegKey(HKEY_CURRENT_USER,"","AutoSearchInSelect"    , AutoSearchInSelect );
     DN_Position = DialogItems[NCI_DN_Position].Selected;
     SetRegKey(HKEY_CURRENT_USER,"","DN_Position"    , DN_Position );
     UpSetRegExp = DialogItems[NCI_UpSetRegExp].Selected;
     SetRegKey(HKEY_CURRENT_USER,"","UpSetRegExp"    , UpSetRegExp );
     KindSelect = DialogItems[NCI_SelStandard].Selected ? 0 : 1;
     SetRegKey(HKEY_CURRENT_USER,"","KindSelect"    , KindSelect );
     CheckESC   = DialogItems[NCI_CheckESC].Selected;
     SetRegKey(HKEY_CURRENT_USER,"","CheckESC"     ,  CheckESC   );
     NoSaveGlobal = DialogItems[NCI_NoSaveGlobal].Selected;
     SetRegKey(HKEY_CURRENT_USER,"","NoSaveGlobal"     ,  NoSaveGlobal );
     NoContinueReplace = DialogItems[NCI_NoContinueReplace].Selected;
     SetRegKey(HKEY_CURRENT_USER,"","NoContinueReplace",  NoContinueReplace );
     CheckEmptyReplace = DialogItems[NCI_CheckEmptyReplace].Selected;
     SetRegKey(HKEY_CURRENT_USER,"","CheckEmptyReplace",  CheckEmptyReplace );
  }

}

//樠樨  室  
static void BegInitExtSearchReg( ExtSearchReg *esr ){

   esr->AllProc = 0;
   esr->NumFindForReplace = 0;
   esr->NumCount = 0;
   esr->Position = 0;
   esr->VirtualSymbols = 0;
   esr->bKeyDownAfterSelect = 0;
   esr->SelectFAR = 1;

   esr->cts   = NULL;
   esr->MaxNumTable = -1;
   esr->NoDialog = 0;
   esr->ExistWinRusTable = 0;
   esr->NumWinRusTable = -1;

   Sel.FindStr = NULL;
}

//********************************************************************
//    
//********************************************************************

void WINAPI _export SetStartupInfo(struct PluginStartupInfo *ExtSearchInfo)
{

  ::ExtSearchInfo=*ExtSearchInfo;

  if( !esr ){
     SetPathsToRegKeys( ExtSearchInfo );  
     //esr = NULL;    
     if( (esr = (ExtSearchReg*)HeapAlloc( GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(ExtSearchReg) )) != NULL ){
        esr->Heap = GetProcessHeap(); 
        //AV 06.12.99 -   ࠡ  ॣ묨 ࠦﬨ
        esr->retest     = new CRegExp;      
        esr->retest_end = new CRegExp;      

        SetWinRusTable( esr );//AV 03.12.99 ।塞  RusWin 㦥   

        OSVERSIONINFO  VersionInformation;
        if ( GetVersionEx( &VersionInformation ) == true ) // points to version information structure
           ESEARCH_RUN_PlatformID = VersionInformation.dwPlatformId;
        else
           ESEARCH_RUN_PlatformID = VER_PLATFORM_WIN32_NT;  // 㬮砭 WinNT

     }
  }
}
#pragma argsused
HANDLE WINAPI _export OpenPlugin(int OpenFrom,int Item)
{

  ExtSearchReg *_esr, 
               *fesr; // ᪠  䠩

  if( esr && Item == 0 ){

     Item = ChoiceFromMenu( OpenFrom );//AV 09.11.99 롮 ࠭ ࠡ  

     if( Item >= 0 ){

          if( OpenFrom == OPEN_EDITOR ){     
             BegInitExtSearchReg( esr );
             esr->SearchInFile = 0;
             //ExtTestMessage( "0" );
             SetCurTable(); // ଠ  ⥪饩 ஢           

             //AV 25.02.00 ⥯     dll  室 樠樨  ࠡ  regexp
             int retcode = ConnectToColorerDLL();
   
             if( !retcode )         SetConnectToColorerDLL =    1;  // 
             else if( retcode < 0 ) SetConnectToColorerDLL =   -1;  //colorer.dll ,  ᠬ colorer 몫祭

             _esr = esr;

          }else{        
             if( (fesr = (ExtSearchReg*)HeapAlloc( GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(ExtSearchReg) )) != NULL ){
                fesr->Heap = GetProcessHeap(); 
                BegInitExtSearchReg( fesr );
                //塞 ᨢ  ⠡
                fesr->cts = (struct CharTableSet *)HeapAlloc( fesr->Heap, HEAP_ZERO_MEMORY, sizeof(struct CharTableSet) );
                for( int i = 0; ExtSearchInfo.CharTable( i, (char*)(fesr->cts+i), sizeof(struct CharTableSet) ) >= 0; i ++ ){
                   fesr->cts =  (struct CharTableSet *)HeapReAlloc( fesr->Heap, HEAP_ZERO_MEMORY, (void*)fesr->cts, sizeof(struct CharTableSet) * (i+2) );                
                   fesr->MaxNumTable = i;
                }
                fesr->SearchInFile = 1;
                fesr->FileCurPos   = 0;
                fesr->ChangeBegStr = 0;

                fesr->retest     = new CRegExp;      
                fesr->retest_end = new CRegExp;      
   
                _esr = fesr;
             }else return(INVALID_HANDLE_VALUE);
          }

          GetWordStr( _esr->SymbWord1Str, _esr->SymbWord2Str, _esr->TemplateGoToError, _esr->PathRootPrj );//砥 ப ᨬ 室  ᫮
     }
     else 
        return esr;

     switch( Item ){
   
        case MP_NUM_SEARCH_INEDIT:
           _esr->Position = 0;
           _esr->VirtualSymbols = 0;//AV 10.12.99
           RunSearch( _esr, 0 );
           break;
        case MP_NUM_SEARCH_REPLACE_INEDIT:
           _esr->Position = 0;
           _esr->VirtualSymbols = 0;//AV 10.12.99
           RunSearchAndReplace( _esr );
           break;
        case MP_NUM_CONTINUE_SEARCH_INEDIT:
           _esr->Position = 1; // 㦥 ᯮ樮஢
           ContinueSearch( _esr );
           break;

        case MP_NUM_REVERSE_SEARCH_INEDIT:
           _esr->Position = 1; // 㦥 ᯮ樮஢
           ReverseSearch( _esr );
           break;

        case MP_NUM_WORD_SEARCH_INEDIT:
           _esr->Position = 1; // 㦥 ᯮ樮஢
           _esr->NoDialog = 1;
           RunSearch( _esr, 1 );
           break;

        case MP_NUM_CLIPBOARD_SEARCH_INEDIT:
           _esr->Position = 1; // 㦥 ᯮ樮஢
           _esr->NoDialog = 1;
           RunSearch( _esr, 2 );
           break;

        case MP_NUM_REVERSE_WORD_SEARCH_INEDIT:
           _esr->Position = 1; // 㦥 ᯮ樮஢
           _esr->NoDialog = 1;
           RunSearch( _esr, 3 );
           break;

        case MP_NUM_REVERSE_CLIPBOARD_SEARCH_INEDIT:
           _esr->Position = 1; // 㦥 ᯮ樮஢
           _esr->NoDialog = 1;
           RunSearch( _esr, 4 );
           break;

        case MP_NUM_GOTO_ERROR_INEDIT: //室  訡, ᠭ  饩 ப
           GoToError( _esr );
           return(INVALID_HANDLE_VALUE);

        case MP_NUM_DEL_EQSTR_INEDIT: //㤠  ப
           DeleteEqString( _esr );
           return(INVALID_HANDLE_VALUE);

        case MP_NUM_SEARCH_INFILES: //  䠩
           fesr->Position = 1;
           fesr->VirtualSymbols = 0;
           fesr->SetDir = 0;
           RunSearchInFile( fesr );
           break;   

        case MP_NUM_REPLACE_INFILES: //  䠩
           fesr->Position = 1;
           fesr->VirtualSymbols = 0;
           fesr->SetDir = 0;
           RunReplaceInFile( fesr );
           break;
 
        case -1: break;//室   롮 ਠ ࠡ 
   
     }

     if( _esr->RXConvertReplace ){ HeapFree( esr->Heap, 0, _esr->RXConvertReplace ); _esr->RXConvertReplace = NULL; }
     if( _esr->FindStr          ){ HeapFree( esr->Heap, 0, _esr->FindStr );          _esr->FindStr = NULL; }
     if( _esr->StringBuff       ){ HeapFree( esr->Heap, 0, _esr->StringBuff  );  _esr->StringBuff = NULL; } 
     if( Sel.FindStr           ){ HeapFree( esr->Heap, 0, Sel.FindStr );           Sel.FindStr = NULL; } 

     if( Item >= MP_NUM_SEARCH_INFILES ){ //⮫쪮 ᫥ ᪠    䠩!
        if( fesr ){
           if( fesr->cts ) { HeapFree( fesr->Heap, 0, fesr->cts ); fesr->cts = NULL; } 
           if( fesr->ReplaceFileBuff  ){ HeapFree( fesr->Heap, 0, fesr->ReplaceFileBuff  ); fesr->ReplaceFileBuff = NULL; } 

           if( fesr->TmpReplaceStr ) { HeapFree( fesr->Heap, 0, fesr->TmpReplaceStr ); fesr->TmpReplaceStr = NULL; }
           if( fesr->_mi ) { HeapFree( fesr->Heap, 0, fesr->_mi ); fesr->_mi = NULL; }
           if( fesr->_fi ) { HeapFree( fesr->Heap, 0, fesr->_fi ); fesr->_fi = NULL; }
           if( fesr->SelItems ) { HeapFree( fesr->Heap, 0, fesr->SelItems ); fesr->SelItems = NULL; };

           delete fesr->retest;
           delete fesr->retest_end;

           HeapFree( fesr->Heap, 0, fesr ); 
        }
     }
  }

  return(INVALID_HANDLE_VALUE);
}

void WINAPI _export ExitFAR( void ){

   delete esr->retest;
   delete esr->retest_end;

   DelAllItemsListSel( &esr->lastsel, &esr->cursel );
   if( esr )  HeapFree( esr->Heap, 0, esr );
}

void WINAPI _export GetPluginInfo(struct PluginInfo *ExtSearchInfo)
{
  ExtSearchInfo->StructSize=sizeof(struct PluginInfo);
  ExtSearchInfo->Flags=PF_EDITOR | PF_PRELOAD; //뢠  । + 易⥫쭠 㧪    FAR;
  ExtSearchInfo->DiskMenuStringsNumber=0;
  static char *PluginMenuStrings[1];//AV 09.11.99 [4]
  PluginMenuStrings[0]=GetMsg(MExtSearchTitle);
  ExtSearchInfo->PluginMenuStrings=PluginMenuStrings;
  ExtSearchInfo->PluginMenuStringsNumber=sizeof(PluginMenuStrings)/sizeof(PluginMenuStrings[0]);

  static char *PluginCfgStrings[1];
  PluginCfgStrings[0]=GetMsg(MExtSearchTitle);
  ExtSearchInfo->PluginConfigStrings=PluginCfgStrings;
  ExtSearchInfo->PluginConfigStringsNumber=sizeof(PluginCfgStrings)/sizeof(PluginCfgStrings[0]);
}

int WINAPI _export Configure(int ItemNumber)
{
  switch(ItemNumber)
  {
    case 0:{
       ExtSearchConfiguration();
    }break;

  }
  return(FALSE);
}

#pragma argsused
int WINAPI _export ProcessEditorEvent( int Event,  void *Param ){

   switch( Event ){
/*      case EE_READ:
          break;     */        

      case EE_REDRAW: 
          if( !esr->SelectFAR && SetConnectToColorerDLL > 0 ) RefreshSelect();//ᮢ, .. ࠡ⠥ Colorer
          
         break;
      case EE_CLOSE:{
         //㤠塞  ᯨ᪠ 
         DelFromListSel( *(int*)Param, &esr->lastsel, &esr->cursel );
         ResetSelect( 0 ); //㤠   
      }
      break;        
   }
   return 0;
}

//#define K_ENTER   13
//#define K_PGUP    33
//#define K_PGDN    34
//#define K_END     35
//#define K_HOME    36
//#define K_LEFT    37
//#define K_UP      38
//#define K_RIGHT   39 
//#define K_DOWN    40 
#define K_INSERT    45
#define K_CTRL      17

int WINAPI _export ProcessEditorInput(INPUT_RECORD *Rec){

  if( esr->SetSelect )   
     if( Rec->EventType == KEY_EVENT &&       
         Rec->Event.KeyEvent.wVirtualKeyCode
       ){
         if( Rec->Event.KeyEvent.bKeyDown == true ){
            if( Rec->Event.KeyEvent.dwControlKeyState == LEFT_CTRL_PRESSED ||
                Rec->Event.KeyEvent.dwControlKeyState == RIGHT_CTRL_PRESSED
              ){
               //⮫쪮  ⮩  Ctrl  ᫨ 뤥 १ ColorAPI
               if( !esr->SelectFAR && !esr->bKeyDownAfterSelect && Rec->Event.KeyEvent.wVirtualKeyCode == K_INSERT && Sel.FindStr && *Sel.FindStr ){
                  //ExtTestMessage( Sel.FindStr );
                  char InClipBoard[LenSearchStr];//AV 23.12.99
                  strncpy( InClipBoard, Sel.FindStr, LenSearchStr-1 );
                  ConvertToOEM( esr, InClipBoard, LenSearchStr );
                  ConvertToWinRus(InClipBoard, LenSearchStr );
                  PutClipBoard(InClipBoard);      
                  return 1; // ⮣ ⮡  CtrlIns   ࠡ⠫
               }


            }
   
            //Rec->Event.KeyEvent.wVirtualKeyCode != K_CTRL  
               if( Rec->Event.KeyEvent.dwControlKeyState != LEFT_CTRL_PRESSED &&
                   Rec->Event.KeyEvent.dwControlKeyState != RIGHT_CTRL_PRESSED &&
                   Rec->Event.KeyEvent.dwControlKeyState != SHIFT_PRESSED  
                 ){// 뢠  ⨨ Ctrl  Shift
      
                  esr->bKeyDownAfterSelect = 1;//, 뫠     ᫥ ᫥ 뤥
                  if( !esr->SelectFAR && SetConnectToColorerDLL <= 0 ){ 
                     //ResetSelect(1);
                     ExtSearchInfo.EditorControl( ECTL_REDRAW, NULL );//㥬  ।
                  }
                  //⠭ ࠭ ⠭⭮ 뤥
                  SetStandardSelect( esr, 1 );                                  
               }
            }
            else
               if( esr->SetSelect && !esr->SelectFAR ) ResetSelect(1);    
         }

     if( esr->AutoSearchInSelect && Rec->EventType == KEY_EVENT && Rec->Event.KeyEvent.wVirtualKeyCode && Rec->Event.KeyEvent.bKeyDown == true )
        if( Rec->Event.KeyEvent.dwControlKeyState == LEFT_CTRL_PRESSED ||
            Rec->Event.KeyEvent.dwControlKeyState == RIGHT_CTRL_PRESSED
          )
            //ࠡ  뤥  Ctrl+U
            if( Rec->Event.KeyEvent.wVirtualKeyCode == 'U' && esr->cursel ){
               esr->cursel->ProcSaveSelectForRestore = 0;
               esr->cursel->ProcResetSelect = 0;//᭨ ਧ 
            }


  return 0;
}
             
